/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern12 (x3); /* [-1, 3] */
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern19 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern19 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  return pattern26 (x5); /* [-1, 1] */
}

int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case PLUS:
      if (GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[2] = x3;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[1] = x1;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern43 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode
      || !gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_HImode))
    return -1;
  return 0;
}

int
pattern53 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern51 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern51 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern52 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern52 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern52 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern52 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern52 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern52 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern52 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern52 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern52 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern52 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != AND
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
    return -1;
  x3 = XEXP (x1, 0);
  return pattern32 (x3); /* [-1, 1] */
}

int
pattern71 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_int_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_V16QImode)
          || !scratch_operand (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_V8HImode)
          || !scratch_operand (operands[3], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_V4SImode)
          || !scratch_operand (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern81 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern83 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_shift_constant (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern88 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern97 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!gpc_reg_operand (operands[1], E_V4SImode))
    return -1;
  x7 = XVECEXP (x5, 0, 0);
  operands[2] = x7;
  if (!const_0_to_3_operand (operands[2], E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_V4SImode))
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_DFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      return 0;

    case E_IFmode:
      if (!gpc_reg_operand (operands[0], E_IFmode)
          || GET_MODE (x3) != E_IFmode)
        return -1;
      return 1;

    case E_KFmode:
      if (!gpc_reg_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode)
        return -1;
      return 2;

    case E_TFmode:
      if (!gpc_reg_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XVECEXP (x1, 0, 3);
  x12 = XEXP (x11, 0);
  operands[5] = x12;
  if (!scratch_operand (operands[5], E_CCUNSmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern110 (x4, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern110 (x4, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern121 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !reg_or_cint_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern128 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 96
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  if (!immediate_operand (operands[0], E_DImode))
    return -1;
  return 0;
}

int
pattern136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      return pattern141 (x3, 
E_V4SFmode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!altivec_register_operand (operands[0], E_V2DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!altivec_register_operand (operands[1], E_V16QImode)
          || !altivec_register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!altivec_register_operand (operands[1], E_V8HImode)
          || !altivec_register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!altivec_register_operand (operands[1], E_V4SImode)
          || !altivec_register_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!altivec_register_operand (operands[1], E_V2DImode)
          || !altivec_register_operand (operands[2], E_V2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern167 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern173 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  return pattern170 (x1); /* [-1, 1] */
}

int
pattern176 (rtx x1, rtx_code i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 106
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern180 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  x7 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x7))
    {
    case CLOBBER:
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      switch (GET_MODE (operands[2]))
        {
        case E_CCmode:
          if (!cc_reg_operand (operands[2], E_CCmode)
              || GET_MODE (x3) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!non_update_memory_operand (operands[1], E_DImode)
                  || !const_m1_to_1_operand (operands[3], E_DImode)
                  || !scratch_operand (operands[0], E_DImode))
                return -1;
              return 0;

            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_m1_to_1_operand (operands[3], E_SImode)
                  || !scratch_operand (operands[0], E_SImode))
                return -1;
              return 1;

            case E_HImode:
              if (!non_update_memory_operand (operands[1], E_HImode)
                  || !const_m1_to_1_operand (operands[3], E_HImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!scratch_operand (operands[0], E_SImode))
                    return -1;
                  return 2;

                case E_DImode:
                  if (!scratch_operand (operands[0], E_DImode))
                    return -1;
                  return 3;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_CCUNSmode:
          if (!cc_reg_operand (operands[2], E_CCUNSmode)
              || GET_MODE (x3) != E_CCUNSmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!non_update_memory_operand (operands[1], E_DImode)
                  || !const_0_to_1_operand (operands[3], E_DImode)
                  || !scratch_operand (operands[0], E_DImode))
                return -1;
              return 4;

            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_0_to_1_operand (operands[3], E_SImode)
                  || !scratch_operand (operands[0], E_SImode))
                return -1;
              return 5;

            case E_HImode:
              res = pattern177 (
E_HImode);
              if (res >= 0)
                return res + 6; /* [6, 7] */
              return -1;

            case E_QImode:
              res = pattern177 (
E_QImode);
              if (res >= 0)
                return res + 8; /* [8, 9] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      x9 = XEXP (x7, 1);
      switch (GET_CODE (x9))
        {
        case MEM:
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_CCmode:
              if (!cc_reg_operand (operands[2], E_CCmode)
                  || GET_MODE (x3) != E_CCmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (!non_update_memory_operand (operands[1], E_DImode)
                      || !const_m1_to_1_operand (operands[3], E_DImode)
                      || !gpc_reg_operand (operands[0], E_DImode))
                    return -1;
                  return 10;

                case E_SImode:
                  if (!non_update_memory_operand (operands[1], E_SImode)
                      || !const_m1_to_1_operand (operands[3], E_SImode)
                      || !gpc_reg_operand (operands[0], E_SImode))
                    return -1;
                  return 11;

                default:
                  return -1;
                }

            case E_CCUNSmode:
              if (!cc_reg_operand (operands[2], E_CCUNSmode)
                  || GET_MODE (x3) != E_CCUNSmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (!non_update_memory_operand (operands[1], E_DImode)
                      || !const_0_to_1_operand (operands[3], E_DImode)
                      || !gpc_reg_operand (operands[0], E_DImode))
                    return -1;
                  return 12;

                case E_SImode:
                  if (!non_update_memory_operand (operands[1], E_SImode)
                      || !const_0_to_1_operand (operands[3], E_SImode)
                      || !gpc_reg_operand (operands[0], E_SImode))
                    return -1;
                  return 13;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (!cc_reg_operand (operands[2], E_CCmode)
              || GET_MODE (x3) != E_CCmode)
            return -1;
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_m1_to_1_operand (operands[3], E_SImode)
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x9) != E_DImode)
                return -1;
              return 14;

            case E_HImode:
              if (!non_update_memory_operand (operands[1], E_HImode)
                  || !const_m1_to_1_operand (operands[3], E_HImode))
                return -1;
              res = pattern178 (x9);
              if (res >= 0)
                return res + 15; /* [15, 16] */
              return -1;

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (!cc_reg_operand (operands[2], E_CCUNSmode)
              || GET_MODE (x3) != E_CCUNSmode)
            return -1;
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_0_to_1_operand (operands[3], E_SImode)
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x9) != E_DImode)
                return -1;
              return 17;

            case E_HImode:
              res = pattern179 (x9, 
E_HImode);
              if (res >= 0)
                return res + 18; /* [18, 19] */
              return -1;

            case E_QImode:
              res = pattern179 (x9, 
E_QImode);
              if (res >= 0)
                return res + 20; /* [20, 21] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern272 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern278 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != XOR)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != NOT)
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 1);
  operands[1] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern276 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern276 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern277 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern277 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern277 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern277 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern277 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern277 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern277 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern277 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern277 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern277 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern302 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern313 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern321 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern332 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 282
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 109
      || GET_MODE (x7) != E_SImode
      || !register_operand (operands[0], i1)
      || !register_operand (operands[1], E_V8HImode))
    return -1;
  x8 = XVECEXP (x3, 0, 1);
  operands[2] = x8;
  if (!register_operand (operands[2], E_V8HImode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[3] = x9;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern346 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2DImode
      || !vsx_register_operand (operands[0], E_V2DImode)
      || !vsx_register_operand (operands[1], E_V2DImode)
      || !vsx_register_operand (operands[2], E_V2DImode))
    return -1;
  return 0;
}

int
pattern352 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], i1)
      || !vsx_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern358 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !boolean_operator (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern364 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern372 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x7))
        {
        case CLOBBER:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              return pattern366 (
E_SImode); /* [-1, 0] */

            case E_DImode:
              if (pattern366 (
E_DImode) != 0)
                return -1;
              return 1;

            default:
              return -1;
            }

        case SET:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x9 = XEXP (x7, 1);
          if (!rtx_equal_p (x9, operands[3]))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern367 (
E_SImode) != 0)
                return -1;
              return 2;

            case E_DImode:
              if (pattern367 (
E_DImode) != 0)
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x10 = XEXP (x5, 0);
          operands[2] = x10;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern368 (x5, 
E_SImode) != 0)
                    return -1;
                  return 4;

                case E_DImode:
                  if (pattern368 (x5, 
E_DImode) != 0)
                    return -1;
                  return 5;

                default:
                  return -1;
                }

            case SET:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              x9 = XEXP (x7, 1);
              if (!rtx_equal_p (x9, operands[3]))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern369 (x5, 
E_SImode) != 0)
                    return -1;
                  return 6;

                case E_DImode:
                  if (pattern369 (x5, 
E_DImode) != 0)
                    return -1;
                  return 7;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x11 = XEXP (x6, 0);
          operands[2] = x11;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern370 (operands[3], 
E_SImode) != 0)
                    return -1;
                  return 8;

                case E_DImode:
                  if (pattern370 (operands[3], 
E_DImode) != 0)
                    return -1;
                  return 9;

                default:
                  return -1;
                }

            case SET:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              x9 = XEXP (x7, 1);
              if (!rtx_equal_p (x9, operands[3]))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern371 (operands[3], 
E_SImode) != 0)
                    return -1;
                  return 10;

                case E_DImode:
                  if (pattern371 (operands[3], 
E_DImode) != 0)
                    return -1;
                  return 11;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern428 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !memory_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !memory_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !memory_operand (operands[1], E_V16QImode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !memory_operand (operands[1], E_V4SFmode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !memory_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !memory_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !memory_operand (operands[1], E_V1TImode))
        return -1;
      return 6;

    case E_KFmode:
      if (!register_operand (operands[0], E_KFmode)
          || !memory_operand (operands[1], E_KFmode))
        return -1;
      return 7;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !memory_operand (operands[1], E_TFmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern455 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!scratch_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern464 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (!register_operand (x3, i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (!register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern468 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern475 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern479 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_SFmode:
      if (!vsx_register_operand (operands[2], E_SFmode)
          || !vsx_register_operand (operands[3], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!vsx_register_operand (operands[2], E_DFmode)
          || !vsx_register_operand (operands[3], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern487 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern495 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern504 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern508 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 98
      || GET_MODE (x3) != E_DImode
      || !gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_DImode
      || !gpc_reg_operand (operands[1], E_DImode)
      || !scc_eq_operand (operands[2], E_DImode)
      || !scratch_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern518 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !d_form_memory (operands[1], i1)
      || !vsx_register_operand (operands[2], E_DImode)
      || !base_reg_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern524 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[2] = x7;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[3] = x8;
  if (!gpc_reg_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern538 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V1TImode:
      if (!register_operand (operands[1], E_V1TImode)
          || !register_operand (operands[2], E_V1TImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !register_operand (operands[2], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern546 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_aligned_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern554 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[4] = x2;
      if (!altivec_register_operand (operands[4], E_V4SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != PLUS
          || GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!gpc_reg_operand (operands[2], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      if (!short_cint_operand (operands[3], E_DImode))
        return -1;
      return 0;

    case MEM:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != PLUS
          || GET_MODE (x7) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[2] = x3;
      if (!altivec_register_operand (operands[2], E_V4SImode))
        return -1;
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      if (!gpc_reg_operand (operands[3], E_DImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[4] = x9;
      if (!short_cint_operand (operands[4], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (scc_rev_comparison_operator (operands[1], E_VOIDmode))
    {
      res = recog_9 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (GET_CODE (x3) != NE)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      if (!zero_constant (operands[2], E_V2DImode))
        return -1;
      x8 = XEXP (x2, 2);
      operands[4] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern477 (x2, 
E_SFmode) != 0
              || !
#line 5742 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
            return -1;
          return 380; /* *xxselsf */

        case E_DFmode:
          if (pattern477 (x2, 
E_DFmode) != 0
              || !
#line 5742 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
            return -1;
          return 381; /* *xxseldf */

        case E_KFmode:
          if (pattern478 (x2, 
E_KFmode) != 0
              || !(
#line 5848 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 388; /* *xxselkf */

        case E_TFmode:
          if (pattern478 (x2, 
E_TFmode) != 0
              || !(
#line 5848 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 389; /* *xxseltf */

        default:
          return -1;
        }

    case LABEL_REF:
      if (pnum_clobbers == NULL)
        return -1;
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC
          || !gpc_reg_operand (operands[1], E_DImode)
          || !const_int_operand (operands[2], E_DImode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[0] = x9;
      if (!
#line 7954 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))))
        return -1;
      *pnum_clobbers = 2;
      return 562; /* *rotate_on_cmpdi */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!gpc_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !gpc_reg_operand (operands[1], E_SImode))
                return -1;
              if (pnum_clobbers != NULL
                  && logical_const_operand (operands[2], E_SImode)
                  && 
#line 3642 "../../gcc/config/rs6000/rs6000.md"
(!rs6000_is_valid_and_mask (operands[2], SImode)))
                {
                  *pnum_clobbers = 1;
                  return 188; /* andsi3_imm */
                }
              if (!const_int_operand (operands[2], E_SImode))
                return -1;
              if (
#line 3773 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_and_mask (operands[2], SImode)))
                return 200; /* andsi3_mask */
              if (!
#line 3840 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))))
                return -1;
              return 206; /* *andsi3_2insn */

            case E_DImode:
              if (!gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !gpc_reg_operand (operands[1], E_DImode))
                return -1;
              if (pnum_clobbers != NULL
                  && logical_const_operand (operands[2], E_DImode)
                  && (
#line 3642 "../../gcc/config/rs6000/rs6000.md"
(!rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                {
                  *pnum_clobbers = 1;
                  return 189; /* anddi3_imm */
                }
              if (!const_int_operand (operands[2], E_DImode))
                return -1;
              if ((
#line 3773 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 201; /* anddi3_mask */
              if (!(
#line 3840 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 207; /* *anddi3_2insn */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (pattern355 (x2, 
E_TImode) != 0)
                return -1;
              return 496; /* *andti3_internal */

            case E_PTImode:
              if (pattern355 (x2, 
E_PTImode) != 0)
                return -1;
              return 497; /* *andpti3_internal */

            case E_V16QImode:
              if (pattern355 (x2, 
E_V16QImode) != 0
                  || !
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 498; /* *andv16qi3_internal */

            case E_V8HImode:
              if (pattern355 (x2, 
E_V8HImode) != 0
                  || !
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 499; /* *andv8hi3_internal */

            case E_V4SImode:
              if (pattern355 (x2, 
E_V4SImode) != 0
                  || !
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 500; /* *andv4si3_internal */

            case E_V4SFmode:
              if (pattern355 (x2, 
E_V4SFmode) != 0
                  || !
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 501; /* *andv4sf3_internal */

            case E_V2DImode:
              if (pattern355 (x2, 
E_V2DImode) != 0
                  || !
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 502; /* *andv2di3_internal */

            case E_V2DFmode:
              if (pattern355 (x2, 
E_V2DFmode) != 0
                  || !
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 503; /* *andv2df3_internal */

            case E_V1TImode:
              if (pattern355 (x2, 
E_V1TImode) != 0
                  || !
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 504; /* *andv1ti3_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
    case ROTATE:
    case LSHIFTRT:
      operands[4] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      if (!reg_or_cint_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern436 (x2, 
E_SImode) != 0
              || !
#line 4182 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_shift_mask (operands[3], operands[4], SImode)))
            return -1;
          return 235; /* *rotlsi3_mask */

        case E_DImode:
          if (pattern436 (x2, 
E_DImode) != 0
              || !(
#line 4182 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_shift_mask (operands[3], operands[4], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 236; /* *rotldi3_mask */

        default:
          return -1;
        }

    case PLUS:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (XWINT (x5, 0) != -16L)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || GET_MODE (x3) != E_DImode)
            return -1;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!gpc_reg_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          if (!reg_or_cint_operand (operands[2], E_DImode)
              || !(
#line 9532 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC && reload_completed) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 630; /* *vec_reload_and_plus_di */

        case REG:
        case SUBREG:
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x5;
          x4 = XEXP (x1, 0);
          operands[3] = x4;
          switch (pattern38 (x2))
            {
            case 0:
              if (!
#line 511 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2398; /* *fuse_add_and */

            case 1:
              if (!(
#line 511 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2399; /* *fuse_add_and */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      return recog_16 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_15 (x1, insn, pnum_clobbers);

    case IOR:
      switch (pattern60 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 421 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2388; /* *fuse_nand_and */

        case 1:
          if (!(
#line 421 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2389; /* *fuse_nand_and */

        case 2:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2580; /* *fuse_vnand_vand */

        case 3:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2581; /* *fuse_vnand_vand */

        case 4:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2582; /* *fuse_vnand_vand */

        case 5:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2583; /* *fuse_vnand_vand */

        case 6:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2584; /* *fuse_vnand_vand */

        case 7:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2585; /* *fuse_vnand_vand */

        case 8:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2586; /* *fuse_vnand_vand */

        case 9:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2587; /* *fuse_vnand_vand */

        case 10:
          if (!(
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2588; /* *fuse_vnand_vand */

        case 11:
          if (!(
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2589; /* *fuse_vnand_vand */

        case 12:
          if (!
#line 601 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2408; /* *fuse_nand_andc */

        case 13:
          if (!(
#line 601 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2409; /* *fuse_nand_andc */

        case 14:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2660; /* *fuse_vnand_vandc */

        case 15:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2661; /* *fuse_vnand_vandc */

        case 16:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2662; /* *fuse_vnand_vandc */

        case 17:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2663; /* *fuse_vnand_vandc */

        case 18:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2664; /* *fuse_vnand_vandc */

        case 19:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2665; /* *fuse_vnand_vandc */

        case 20:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2666; /* *fuse_vnand_vandc */

        case 21:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2667; /* *fuse_vnand_vandc */

        case 22:
          if (!(
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2668; /* *fuse_vnand_vandc */

        case 23:
          if (!(
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2669; /* *fuse_vnand_vandc */

        case 24:
          if (!
#line 475 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2394; /* *fuse_orc_and */

        case 25:
          if (!(
#line 475 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2395; /* *fuse_orc_and */

        case 26:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2610; /* *fuse_vorc_vand */

        case 27:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2611; /* *fuse_vorc_vand */

        case 28:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2612; /* *fuse_vorc_vand */

        case 29:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2613; /* *fuse_vorc_vand */

        case 30:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2614; /* *fuse_vorc_vand */

        case 31:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2615; /* *fuse_vorc_vand */

        case 32:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2616; /* *fuse_vorc_vand */

        case 33:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2617; /* *fuse_vorc_vand */

        case 34:
          if (!(
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2618; /* *fuse_vorc_vand */

        case 35:
          if (!(
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2619; /* *fuse_vorc_vand */

        case 36:
          if (!
#line 655 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2414; /* *fuse_orc_andc */

        case 37:
          if (!(
#line 655 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2415; /* *fuse_orc_andc */

        case 38:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2690; /* *fuse_vorc_vandc */

        case 39:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2691; /* *fuse_vorc_vandc */

        case 40:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2692; /* *fuse_vorc_vandc */

        case 41:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2693; /* *fuse_vorc_vandc */

        case 42:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2694; /* *fuse_vorc_vandc */

        case 43:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2695; /* *fuse_vorc_vandc */

        case 44:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2696; /* *fuse_vorc_vandc */

        case 45:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2697; /* *fuse_vorc_vandc */

        case 46:
          if (!(
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2698; /* *fuse_vorc_vandc */

        case 47:
          if (!(
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2699; /* *fuse_vorc_vandc */

        case 48:
          if (!
#line 457 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2392; /* *fuse_or_and */

        case 49:
          if (!(
#line 457 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2393; /* *fuse_or_and */

        case 50:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2600; /* *fuse_vor_vand */

        case 51:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2601; /* *fuse_vor_vand */

        case 52:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2602; /* *fuse_vor_vand */

        case 53:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2603; /* *fuse_vor_vand */

        case 54:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2604; /* *fuse_vor_vand */

        case 55:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2605; /* *fuse_vor_vand */

        case 56:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2606; /* *fuse_vor_vand */

        case 57:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2607; /* *fuse_vor_vand */

        case 58:
          if (!(
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2608; /* *fuse_vor_vand */

        case 59:
          if (!(
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2609; /* *fuse_vor_vand */

        case 60:
          if (!
#line 637 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2412; /* *fuse_or_andc */

        case 61:
          if (!(
#line 637 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2413; /* *fuse_or_andc */

        case 62:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2680; /* *fuse_vor_vandc */

        case 63:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2681; /* *fuse_vor_vandc */

        case 64:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2682; /* *fuse_vor_vandc */

        case 65:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2683; /* *fuse_vor_vandc */

        case 66:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2684; /* *fuse_vor_vandc */

        case 67:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2685; /* *fuse_vor_vandc */

        case 68:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2686; /* *fuse_vor_vandc */

        case 69:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2687; /* *fuse_vor_vandc */

        case 70:
          if (!(
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2688; /* *fuse_vor_vandc */

        case 71:
          if (!(
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2689; /* *fuse_vor_vandc */

        default:
          return -1;
        }

    case XOR:
      switch (pattern61 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 493 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2396; /* *fuse_xor_and */

        case 1:
          if (!(
#line 493 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2397; /* *fuse_xor_and */

        case 2:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2620; /* *fuse_vxor_vand */

        case 3:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2621; /* *fuse_vxor_vand */

        case 4:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2622; /* *fuse_vxor_vand */

        case 5:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2623; /* *fuse_vxor_vand */

        case 6:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2624; /* *fuse_vxor_vand */

        case 7:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2625; /* *fuse_vxor_vand */

        case 8:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2626; /* *fuse_vxor_vand */

        case 9:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2627; /* *fuse_vxor_vand */

        case 10:
          if (!(
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2628; /* *fuse_vxor_vand */

        case 11:
          if (!(
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2629; /* *fuse_vxor_vand */

        case 12:
          if (!
#line 673 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2416; /* *fuse_xor_andc */

        case 13:
          if (!(
#line 673 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2417; /* *fuse_xor_andc */

        case 14:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2700; /* *fuse_vxor_vandc */

        case 15:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2701; /* *fuse_vxor_vandc */

        case 16:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2702; /* *fuse_vxor_vandc */

        case 17:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2703; /* *fuse_vxor_vandc */

        case 18:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2704; /* *fuse_vxor_vandc */

        case 19:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2705; /* *fuse_vxor_vandc */

        case 20:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2706; /* *fuse_vxor_vandc */

        case 21:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2707; /* *fuse_vxor_vandc */

        case 22:
          if (!(
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2708; /* *fuse_vxor_vandc */

        case 23:
          if (!(
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2709; /* *fuse_vxor_vandc */

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern120 (x1))
        {
        case 0:
          if (!
#line 529 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2400; /* *fuse_subf_and */

        case 1:
          if (!(
#line 529 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2401; /* *fuse_subf_and */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!u7bit_cint_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!vsx_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 5497 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1584; /* xvtstdcsp */

    case E_V2DImode:
      if (!vsx_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 5497 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1585; /* xvtstdcdp */

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0
          || !
#line 2045 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1911; /* altivec_vrldnm */

    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0
          || !
#line 2045 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1912; /* altivec_vrlwnm */

    case E_V1TImode:
      if (pattern131 (x3, 
E_V1TImode) != 0
          || !
#line 2069 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 1913; /* altivec_vrlqnm_inst */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (pattern131 (x3, 
E_V4SFmode) != 0
          || !
#line 5484 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1582; /* xviexpsp */

    case E_V2DFmode:
      if (pattern131 (x3, 
E_V2DFmode) != 0
          || !
#line 5484 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1583; /* xviexpdp */

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!vsx_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || !vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 6488 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1644; /* vec_expand_v16qi */

    case E_V8HImode:
      if (!vsx_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !vsx_register_operand (operands[1], E_V8HImode)
          || !
#line 6488 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1645; /* vec_expand_v8hi */

    case E_V4SImode:
      if (!vsx_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode
          || !vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 6488 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1646; /* vec_expand_v4si */

    case E_V2DImode:
      if (!vsx_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode
          || !vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 6488 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1647; /* vec_expand_v2di */

    case E_V1TImode:
      if (!vsx_register_operand (operands[0], E_V1TImode)
          || GET_MODE (x2) != E_V1TImode
          || !vsx_register_operand (operands[1], E_V1TImode)
          || !
#line 6488 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1648; /* vec_expand_v1ti */

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SFmode)
    return -1;
  if (nonimmediate_operand (operands[0], E_SFmode))
    {
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (input_operand (operands[1], E_SImode)
          && 
#line 8385 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SFmode)
       || register_operand (operands[1], SImode))))
        {
          *pnum_clobbers = 1;
          return 575; /* movsf_from_si */
        }
    }
  x3 = XVECEXP (x2, 0, 0);
  if (!lowpart_subreg_operator (x3, E_SImode))
    return -1;
  operands[3] = x3;
  if (!gpc_reg_operand (operands[0], E_SFmode))
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case ASHIFTRT:
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!input_operand (operands[1], E_DImode)
          || !
#line 8452 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG))
        return -1;
      *pnum_clobbers = 1;
      return 576; /* movsf_from_si2_ashiftrt */

    case LSHIFTRT:
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!input_operand (operands[1], E_DImode)
          || !
#line 8452 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG))
        return -1;
      *pnum_clobbers = 1;
      return 577; /* movsf_from_si2_lshiftrt */

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2463 "../../gcc/config/rs6000/vsx.md"
(TARGET_XSCVSPDPN))
        return -1;
      return 1323; /* vsx_xscvspdpn */

    case E_SFmode:
      if (!vsx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || !vsx_register_operand (operands[1], E_SFmode)
          || !
#line 2480 "../../gcc/config/rs6000/vsx.md"
(TARGET_XSCVSPDPN))
        return -1;
      return 1325; /* vsx_xscvspdpn_directmove */

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      switch (pattern321 (x2, 
E_V1TImode))
        {
        case 0:
          if (!(
#line 5219 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1556; /* xsxsigqp_kf_v1ti */

        case 1:
          if (!(
#line 5219 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1557; /* xsxsigqp_tf_v1ti */

        default:
          return -1;
        }

    case E_TImode:
      switch (pattern321 (x2, 
E_TImode))
        {
        case 0:
          if (!(
#line 5219 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1558; /* xsxsigqp_kf_ti */

        case 1:
          if (!(
#line 5219 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1559; /* xsxsigqp_tf_ti */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_3_operand (operands[3], E_SImode))
    return -1;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_DDmode:
          if (pattern364 (x3, 
E_DDmode) != 0
              || !
#line 406 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2320; /* dfp_dqua_dd */

        case E_TDmode:
          if (pattern364 (x3, 
E_TDmode) != 0
              || !
#line 406 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2321; /* dfp_dqua_td */

        default:
          return -1;
        }

    case CONST_INT:
      if (!s5bit_cint_operand (operands[1], E_SImode))
        return -1;
      switch (pattern365 (x3))
        {
        case 0:
          if (!
#line 417 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2322; /* dfp_dquai_dd */

        case 1:
          if (!
#line 417 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2323; /* dfp_dquai_td */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 2:
      return recog_104 (x1, insn, pnum_clobbers);

    case 1:
      return recog_105 (x1, insn, pnum_clobbers);

    case 3:
      return recog_106 (x1, insn, pnum_clobbers);

    case 4:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      switch (XINT (x2, 1))
        {
        case 208:
          if (pattern416 (x2, 
E_V16QImode) != 0
              || !u3bit_cint_operand (operands[4], E_QImode)
              || !
#line 6746 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1677; /* xxpermx_inst */

        case 203:
          if (pattern416 (x2, 
E_V2DImode) != 0
              || !u8bit_cint_operand (operands[4], E_QImode)
              || !
#line 6759 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1678; /* xxeval */

        case 373:
          if (pattern417 (x2, 
E_V16QImode) != 0
              || !const_0_to_15_operand (operands[4], E_SImode)
              || !
#line 624 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2261; /* mma_pmxvf32ger */

        case 378:
          if (pattern417 (x2, 
E_OOmode) != 0
              || !const_0_to_3_operand (operands[4], E_SImode)
              || !
#line 649 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2266; /* mma_pmxvf64ger */

        default:
          return -1;
        }

    case 5:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_reg_operand (operands[0], E_XOmode)
          || GET_MODE (x2) != E_XOmode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      if (!const_0_to_15_operand (operands[4], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[5] = x8;
      switch (XINT (x2, 1))
        {
        case 387:
          if (!vsx_register_operand (operands[1], E_V16QImode)
              || !vsx_register_operand (operands[2], E_V16QImode)
              || !const_0_to_15_operand (operands[3], E_SImode)
              || !u8bit_cint_operand (operands[5], E_SImode)
              || !
#line 571 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2245; /* mma_pmxvi4ger8 */

        case 383:
          if (pattern511 () != 0
              || !
#line 598 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2247; /* mma_pmxvi16ger2 */

        case 385:
          if (pattern511 () != 0
              || !
#line 598 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2248; /* mma_pmxvi16ger2s */

        case 368:
          if (pattern511 () != 0
              || !
#line 598 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2249; /* mma_pmxvf16ger2 */

        case 363:
          if (pattern511 () != 0
              || !
#line 598 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2250; /* mma_pmxvbf16ger2 */

        case 377:
          if (pattern512 () != 0
              || !
#line 637 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2262; /* mma_pmxvf32gerpp */

        case 376:
          if (pattern512 () != 0
              || !
#line 637 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2263; /* mma_pmxvf32gerpn */

        case 375:
          if (pattern512 () != 0
              || !
#line 637 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2264; /* mma_pmxvf32gernp */

        case 374:
          if (pattern512 () != 0
              || !
#line 637 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2265; /* mma_pmxvf32gernn */

        case 382:
          if (pattern513 () != 0
              || !
#line 662 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2267; /* mma_pmxvf64gerpp */

        case 381:
          if (pattern513 () != 0
              || !
#line 662 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2268; /* mma_pmxvf64gerpn */

        case 380:
          if (pattern513 () != 0
              || !
#line 662 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2269; /* mma_pmxvf64gernp */

        case 379:
          if (pattern513 () != 0
              || !
#line 662 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2270; /* mma_pmxvf64gernn */

        case 389:
          if (!vsx_register_operand (operands[1], E_V16QImode)
              || !vsx_register_operand (operands[2], E_V16QImode)
              || !const_0_to_15_operand (operands[3], E_SImode)
              || !const_0_to_15_operand (operands[5], E_SImode)
              || !
#line 675 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2271; /* mma_pmxvi8ger4 */

        default:
          return -1;
        }

    case 6:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_reg_operand (operands[0], E_XOmode)
          || GET_MODE (x2) != E_XOmode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!fpr_reg_operand (operands[1], E_XOmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!vsx_register_operand (operands[2], E_V16QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!vsx_register_operand (operands[3], E_V16QImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      if (!const_0_to_15_operand (operands[4], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[5] = x8;
      if (!const_0_to_15_operand (operands[5], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 5);
      operands[6] = x9;
      switch (XINT (x2, 1))
        {
        case 388:
          if (!u8bit_cint_operand (operands[6], E_SImode)
              || !
#line 585 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2246; /* mma_pmxvi4ger8pp */

        case 384:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2251; /* mma_pmxvi16ger2pp */

        case 386:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2252; /* mma_pmxvi16ger2spp */

        case 372:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2253; /* mma_pmxvf16ger2pp */

        case 371:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2254; /* mma_pmxvf16ger2pn */

        case 370:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2255; /* mma_pmxvf16ger2np */

        case 369:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2256; /* mma_pmxvf16ger2nn */

        case 367:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2257; /* mma_pmxvbf16ger2pp */

        case 366:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2258; /* mma_pmxvbf16ger2pn */

        case 365:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2259; /* mma_pmxvbf16ger2np */

        case 364:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 612 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2260; /* mma_pmxvbf16ger2nn */

        case 390:
          if (!const_0_to_15_operand (operands[6], E_SImode)
              || !
#line 689 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2272; /* mma_pmxvi8ger4pp */

        case 391:
          if (!const_0_to_15_operand (operands[6], E_SImode)
              || !
#line 689 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2273; /* mma_pmxvi8ger4spp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !gpc_reg_operand (operands[1], E_SImode))
            return -1;
          return 116; /* negsi2 */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !gpc_reg_operand (operands[1], E_DImode)
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 117; /* negdi2 */

        case E_SFmode:
          if (!gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 5044 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 299; /* *negsf2_fpr */

        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !gpc_reg_operand (operands[1], E_DFmode)
              || !
#line 5044 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 300; /* *negdf2_fpr */

        case E_IFmode:
          if (!gpc_reg_operand (operands[0], E_IFmode)
              || GET_MODE (x3) != E_IFmode
              || !gpc_reg_operand (operands[1], E_IFmode)
              || !(
#line 9205 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
            return -1;
          return 612; /* negif2_internal */

        case E_TFmode:
          if (GET_MODE (x3) != E_TFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_TFmode)
              && gpc_reg_operand (operands[1], E_TFmode)
              && (
#line 9205 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
            return 613; /* negtf2_internal */
          if (pnum_clobbers != NULL
              && register_operand (operands[0], E_TFmode)
              && register_operand (operands[1], E_TFmode)
              && (
#line 9299 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            {
              *pnum_clobbers = 1;
              return 615; /* ieee_128bit_vsx_negtf2 */
            }
          if (!altivec_register_operand (operands[0], E_TFmode)
              || !altivec_register_operand (operands[1], E_TFmode)
              || !(
#line 15122 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1002; /* negtf2_hw */

        case E_KFmode:
          if (pnum_clobbers != NULL
              && register_operand (operands[0], E_KFmode)
              && GET_MODE (x3) == E_KFmode
              && register_operand (operands[1], E_KFmode)
              && (
#line 9299 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            {
              *pnum_clobbers = 1;
              return 614; /* ieee_128bit_vsx_negkf2 */
            }
          if (!altivec_register_operand (operands[0], E_KFmode)
              || GET_MODE (x3) != E_KFmode
              || !altivec_register_operand (operands[1], E_KFmode)
              || !(
#line 15122 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1001; /* negkf2_hw */

        case E_V4SFmode:
          if (!vsx_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !vsx_register_operand (operands[1], E_V4SFmode)
              || !
#line 1984 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1250; /* *vsx_negv4sf2 */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 1984 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1251; /* *vsx_negv2df2 */

        case E_V4SImode:
          if (!altivec_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !altivec_register_operand (operands[1], E_V4SImode)
              || !
#line 3731 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2140; /* *p9_negv4si2 */

        case E_V2DImode:
          if (!altivec_register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !altivec_register_operand (operands[1], E_V2DImode)
              || !
#line 3731 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2141; /* *p9_negv2di2 */

        case E_DDmode:
          if (!gpc_reg_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !gpc_reg_operand (operands[1], E_DDmode)
              || !
#line 87 "../../gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2278; /* negdd2 */

        case E_TDmode:
          if (!gpc_reg_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !gpc_reg_operand (operands[1], E_TDmode)
              || !
#line 108 "../../gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2281; /* negtd2 */

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern203 (x3, 
E_SFmode) != 0
              || !
#line 5029 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 297; /* *nabssf2_fpr */

        case E_DFmode:
          if (pattern203 (x3, 
E_DFmode) != 0
              || !
#line 5029 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 298; /* *nabsdf2_fpr */

        case E_KFmode:
          if (pnum_clobbers != NULL
              && pattern265 (x3, 
E_KFmode) == 0
              && (
#line 9357 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            {
              *pnum_clobbers = 1;
              return 622; /* *ieee_128bit_vsx_nabskf2 */
            }
          if (!altivec_register_operand (operands[0], E_KFmode)
              || GET_MODE (x3) != E_KFmode
              || GET_MODE (x4) != E_KFmode
              || !altivec_register_operand (operands[1], E_KFmode)
              || !(
#line 15143 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1005; /* *nabskf2_hw */

        case E_TFmode:
          if (pnum_clobbers != NULL
              && pattern265 (x3, 
E_TFmode) == 0
              && (
#line 9357 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            {
              *pnum_clobbers = 1;
              return 623; /* *ieee_128bit_vsx_nabstf2 */
            }
          if (!altivec_register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || GET_MODE (x4) != E_TFmode
              || !altivec_register_operand (operands[1], E_TFmode)
              || !(
#line 15143 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1006; /* *nabstf2_hw */

        case E_V4SFmode:
          if (pattern204 (x3, 
E_V4SFmode) != 0
              || !
#line 2000 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1254; /* vsx_nabsv4sf2 */

        case E_V2DFmode:
          if (pattern204 (x3, 
E_V2DFmode) != 0
              || !
#line 2000 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1255; /* vsx_nabsv2df2 */

        case E_DDmode:
          if (pattern203 (x3, 
E_DDmode) != 0
              || !
#line 101 "../../gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2280; /* *nabsdd2_fpr */

        case E_TDmode:
          if (pattern203 (x3, 
E_TDmode) != 0
              || !
#line 128 "../../gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2283; /* *nabstd2_fpr */

        default:
          return -1;
        }

    case EQ:
    case GT:
    case LT:
    case GTU:
    case LTU:
    case UNORDERED:
      operands[1] = x4;
      res = recog_5 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || pattern119 (x3, 
EQ) != 0
          || !(
#line 13026 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 3;
      return 861; /* *neg_eq_di */

    case NE:
    case GE:
    case LE:
    case GEU:
    case LEU:
    case ORDERED:
      operands[1] = x4;
      res = recog_6 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || pattern119 (x3, 
NE) != 0
          || !(
#line 13058 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 3;
      return 862; /* *neg_ne_di */

    case FMA:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 2);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern350 (x3, 
E_SFmode) != 0
                  || !
#line 14538 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 951; /* *nfmasf4_fpr */

            case E_DFmode:
              if (pattern350 (x3, 
E_DFmode) != 0
                  || !
#line 14538 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 952; /* *nfmadf4_fpr */

            case E_KFmode:
              if (pattern351 (x3, 
E_KFmode) != 0
                  || !(
#line 15179 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1011; /* *nfmakf4_hw */

            case E_TFmode:
              if (pattern351 (x3, 
E_TFmode) != 0
                  || !(
#line 15179 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1012; /* *nfmatf4_hw */

            case E_V4SFmode:
              if (pattern352 (x3, 
E_V4SFmode) != 0
                  || !
#line 2120 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                return -1;
              return 1271; /* *vsx_nfmav4sf4 */

            case E_V2DFmode:
              if (pattern352 (x3, 
E_V2DFmode) != 0
                  || !
#line 2120 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1272; /* *vsx_nfmav2df4 */

            default:
              return -1;
            }

        case NEG:
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern353 (x3, 
E_SFmode) != 0
                  || !
#line 14565 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 953; /* *nfmssf4_fpr */

            case E_DFmode:
              if (pattern353 (x3, 
E_DFmode) != 0
                  || !
#line 14565 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 954; /* *nfmssf4_fpr */

            case E_KFmode:
              if (pattern354 (x3, 
E_KFmode) != 0
                  || !(
#line 15192 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1013; /* *nfmskf4_hw */

            case E_TFmode:
              if (pattern354 (x3, 
E_TFmode) != 0
                  || !(
#line 15192 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1014; /* *nfmstf4_hw */

            case E_V4SFmode:
              if (GET_MODE (x3) != E_V4SFmode
                  || GET_MODE (x4) != E_V4SFmode
                  || GET_MODE (x7) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[0], E_V4SFmode)
                  && vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[2], E_V4SFmode)
                  && vsx_register_operand (operands[3], E_V4SFmode)
                  && 
#line 2134 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                return 1273; /* *vsx_nfmsv4sf4 */
              if (!register_operand (operands[0], E_V4SFmode)
                  || !register_operand (operands[1], E_V4SFmode)
                  || !register_operand (operands[2], E_V4SFmode)
                  || !register_operand (operands[3], E_V4SFmode)
                  || !
#line 1001 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return -1;
              return 1815; /* *altivec_vnmsubfp */

            case E_V2DFmode:
              if (!vsx_register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x3) != E_V2DFmode
                  || GET_MODE (x4) != E_V2DFmode
                  || !vsx_register_operand (operands[1], E_V2DFmode)
                  || !vsx_register_operand (operands[2], E_V2DFmode)
                  || GET_MODE (x7) != E_V2DFmode
                  || !vsx_register_operand (operands[3], E_V2DFmode)
                  || !
#line 2148 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1274; /* *vsx_nfmsv2df4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 82)
        return -1;
      x9 = XVECEXP (x4, 0, 0);
      operands[1] = x9;
      x10 = XVECEXP (x4, 0, 1);
      operands[2] = x10;
      x11 = XVECEXP (x4, 0, 2);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[3] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_KFmode:
              if (pattern433 (x3, 
E_KFmode) != 0
                  || !(
#line 15570 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1091; /* *nfmakf4_odd */

            case E_TFmode:
              if (pattern433 (x3, 
E_TFmode) != 0
                  || !(
#line 15570 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1092; /* *nfmatf4_odd */

            default:
              return -1;
            }

        case NEG:
          x12 = XEXP (x11, 0);
          operands[3] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_KFmode:
              if (pattern434 (x3, 
E_KFmode) != 0
                  || !(
#line 15584 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1093; /* *nfmskf4_odd */

            case E_TFmode:
              if (pattern434 (x3, 
E_TFmode) != 0
                  || !(
#line 15584 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1094; /* *nfmstf4_odd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_128 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!reg_or_mem_operand (operands[1], E_QImode))
                return -1;
              return 4; /* zero_extendqisi2 */

            case E_HImode:
              if (!reg_or_mem_operand (operands[1], E_HImode))
                return -1;
              return 10; /* zero_extendhisi2 */

            default:
              return -1;
            }

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!reg_or_mem_operand (operands[1], E_QImode)
                  || !
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 5; /* zero_extendqidi2 */

            case E_HImode:
              if (!reg_or_mem_operand (operands[1], E_HImode)
                  || !
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 11; /* zero_extendhidi2 */

            case E_SImode:
              if (!reg_or_mem_operand (operands[1], E_SImode)
                  || !
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 16; /* zero_extendsidi2 */

            default:
              return -1;
            }

        case E_TImode:
          if (!vsx_register_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!memory_operand (operands[1], E_QImode)
                  || !
#line 1373 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1205; /* vsx_lxvrbx */

            case E_HImode:
              if (!memory_operand (operands[1], E_HImode)
                  || !
#line 1373 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1206; /* vsx_lxvrhx */

            case E_SImode:
              if (!memory_operand (operands[1], E_SImode)
                  || !
#line 1373 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1207; /* vsx_lxvrwx */

            case E_DImode:
              if (!memory_operand (operands[1], E_DImode)
                  || !
#line 1373 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1208; /* vsx_lxvrdx */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case BSWAP:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_HImode:
              if (!memory_operand (operands[1], E_HImode)
                  || !
#line 2610 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 139; /* *bswaphi2_extenddi */

            case E_SImode:
              if (!memory_operand (operands[1], E_SImode)
                  || !
#line 2610 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 140; /* *bswapsi2_extenddi */

            default:
              return -1;
            }

        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_HImode
              || !memory_operand (operands[1], E_HImode))
            return -1;
          return 141; /* *bswaphi2_extendsi */

        default:
          return -1;
        }

    case ROTATE:
      if (GET_MODE (x4) != E_SImode
          || pattern118 (x3, 
E_SImode) != 0
          || !
#line 4579 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      return 266; /* *rotlsi3_64 */

    case ASHIFT:
      if (GET_MODE (x4) != E_SImode
          || pattern118 (x3, 
E_SImode) != 0
          || !
#line 4647 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      return 273; /* *ashlsi3_64 */

    case LSHIFTRT:
      if (GET_MODE (x4) != E_SImode
          || pattern118 (x3, 
E_SImode) != 0
          || !
#line 4836 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      return 283; /* *lshrsi3_64 */

    case UNSPEC:
      switch (XVECLEN (x4, 0))
        {
        case 1:
          if (GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          operands[1] = x6;
          switch (XINT (x4, 1))
            {
            case 87:
              if (pnum_clobbers == NULL
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || !input_operand (operands[1], E_SFmode)
                  || !
#line 7892 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT
   && (register_operand (operands[0], DImode)
       || register_operand (operands[1], SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 559; /* *movdi_from_sf_zero_ext */

            case 168:
              switch (pattern349 ())
                {
                case 0:
                  if (!
#line 5954 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1603; /* *vclzlsbb_zext_v16qi */

                case 1:
                  if (!
#line 5954 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1605; /* *vclzlsbb_zext_v8hi */

                case 2:
                  if (!
#line 5954 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1607; /* *vclzlsbb_zext_v4si */

                default:
                  return -1;
                }

            case 169:
              switch (pattern349 ())
                {
                case 0:
                  if (!
#line 5954 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1604; /* *vctzlsbb_zext_v16qi */

                case 1:
                  if (!
#line 5954 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1606; /* *vctzlsbb_zext_v8hi */

                case 2:
                  if (!
#line 5954 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1608; /* *vctzlsbb_zext_v4si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 3:
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern198 (x4))
            {
            case 0:
              if (!int_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_SImode:
                  if (!d_form_memory (operands[1], E_SImode)
                      || !(
#line 170 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3202; /* *pcrel_opt_ldsi_udi_gpr */

                case E_HImode:
                  if (!d_form_memory (operands[1], E_HImode)
                      || !(
#line 185 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3206; /* *pcrel_opt_ldhi_udi_gpr */

                case E_QImode:
                  if (!d_form_memory (operands[1], E_QImode)
                      || !(
#line 200 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3208; /* *pcrel_opt_ldqi_udi_gpr */

                default:
                  return -1;
                }

            case 1:
              if (!int_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_HImode:
                  if (!d_form_memory (operands[1], E_HImode)
                      || !
#line 185 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3204; /* *pcrel_opt_ldhi_usi_gpr */

                case E_QImode:
                  if (!d_form_memory (operands[1], E_QImode)
                      || !
#line 200 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3207; /* *pcrel_opt_ldqi_usi_gpr */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (vsx_register_operand (operands[1], E_V4SImode)
          && register_operand (operands[0], E_DImode)
          && GET_MODE (x4) == E_SImode)
        {
          x8 = XVECEXP (x7, 0, 0);
          operands[2] = x8;
          if (const_int_operand (operands[2], E_QImode)
              && 
#line 3957 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 1 : 2)))
            {
              *pnum_clobbers = 1;
              return 1406; /* *mfvsrwz */
            }
        }
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_QImode:
          if (!gpc_reg_operand (operands[1], E_V16QImode)
              || !
#line 4025 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB))
            return -1;
          *pnum_clobbers = 1;
          return 1410; /* *vsx_extract_v16qi_di_p9 */

        case E_HImode:
          if (!gpc_reg_operand (operands[1], E_V8HImode)
              || !
#line 4025 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB))
            return -1;
          *pnum_clobbers = 1;
          return 1411; /* *vsx_extract_v8hi_di_p9 */

        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_V4SImode)
              || !
#line 4025 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB))
            return -1;
          *pnum_clobbers = 1;
          return 1412; /* *vsx_extract_v4si_di_p9 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_134 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !gpc_reg_operand (operands[1], E_SImode))
            return -1;
          return 88; /* *one_cmplsi2 */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !gpc_reg_operand (operands[1], E_DImode)
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 89; /* *one_cmpldi2 */

        case E_TImode:
          if (!vlogical_operand (operands[0], E_TImode)
              || GET_MODE (x2) != E_TImode
              || !vlogical_operand (operands[1], E_TImode))
            return -1;
          return 547; /* one_cmplti2 */

        case E_PTImode:
          if (!vlogical_operand (operands[0], E_PTImode)
              || GET_MODE (x2) != E_PTImode
              || !vlogical_operand (operands[1], E_PTImode))
            return -1;
          return 548; /* one_cmplpti2 */

        case E_V16QImode:
          if (!vlogical_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !vlogical_operand (operands[1], E_V16QImode)
              || !
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 549; /* one_cmplv16qi2 */

        case E_V8HImode:
          if (!vlogical_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !vlogical_operand (operands[1], E_V8HImode)
              || !
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 550; /* one_cmplv8hi2 */

        case E_V4SImode:
          if (!vlogical_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !vlogical_operand (operands[1], E_V4SImode)
              || !
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 551; /* one_cmplv4si2 */

        case E_V4SFmode:
          if (!vlogical_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !vlogical_operand (operands[1], E_V4SFmode)
              || !
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 552; /* one_cmplv4sf2 */

        case E_V2DImode:
          if (!vlogical_operand (operands[0], E_V2DImode)
              || GET_MODE (x2) != E_V2DImode
              || !vlogical_operand (operands[1], E_V2DImode)
              || !
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 553; /* one_cmplv2di2 */

        case E_V2DFmode:
          if (!vlogical_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !vlogical_operand (operands[1], E_V2DFmode)
              || !
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 554; /* one_cmplv2df2 */

        case E_V1TImode:
          if (!vlogical_operand (operands[0], E_V1TImode)
              || GET_MODE (x2) != E_V1TImode
              || !vlogical_operand (operands[1], E_V1TImode)
              || !
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 555; /* one_cmplv1ti2 */

        default:
          return -1;
        }

    case XOR:
      return recog_4 (x1, insn, pnum_clobbers);

    case EQ:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern264 (x2, 
E_V16QImode) != 0
              || !
#line 5863 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1596; /* vcmpneb */

        case E_V8HImode:
          if (pattern264 (x2, 
E_V8HImode) != 0
              || !
#line 5913 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1599; /* vcmpneh */

        case E_V4SImode:
          if (pattern264 (x2, 
E_V4SImode) != 0
              || !
#line 5933 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1601; /* vcmpnew */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_141 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern5 (x1, pnum_clobbers))
    {
    case 0:
      if (vsx_register_operand (operands[0], E_SFmode)
          && vsx_register_operand (operands[1], E_SFmode)
          && vsx_register_operand (operands[2], E_SFmode)
          && 
#line 5488 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && TARGET_HARD_FLOAT))
        return 326; /* *sminsf3_vsx */
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !gpc_reg_operand (operands[2], E_SFmode)
          || !
#line 5515 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX))
        return -1;
      return 334; /* *sminsf3_fpr */

    case 1:
      if (vsx_register_operand (operands[0], E_DFmode)
          && vsx_register_operand (operands[1], E_DFmode)
          && vsx_register_operand (operands[2], E_DFmode)
          && 
#line 5488 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && TARGET_HARD_FLOAT))
        return 328; /* *smindf3_vsx */
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || !gpc_reg_operand (operands[1], E_DFmode)
          || !gpc_reg_operand (operands[2], E_DFmode)
          || !
#line 5515 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX))
        return -1;
      return 336; /* *smindf3_fpr */

    case 2:
      if (!(
#line 5502 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 330; /* sminkf3 */

    case 3:
      if (!(
#line 5502 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 332; /* smintf3 */

    case 4:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && vsx_register_operand (operands[2], E_V4SFmode)
          && 
#line 2016 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1258; /* *vsx_sminv4sf3 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !register_operand (operands[2], E_V4SFmode)
          || !
#line 1113 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
        return -1;
      return 1841; /* *altivec_sminv4sf3 */

    case 5:
      if (!
#line 2016 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1259; /* *vsx_sminv2df3 */

    case 6:
      if (!
#line 1105 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
        return -1;
      return 1837; /* sminv4si3 */

    case 7:
      if (!
#line 1105 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
        return -1;
      return 1838; /* sminv8hi3 */

    case 8:
      if (!
#line 1105 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
        return -1;
      return 1839; /* sminv16qi3 */

    case 9:
      if (!
#line 1105 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
        return -1;
      return 1840; /* sminv2di3 */

    case 10:
      if (!
#line 4927 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      *pnum_clobbers = 1;
      return 1527; /* vsx_reduc_smin_v2df */

    case 11:
      if (!
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      *pnum_clobbers = 2;
      return 1530; /* vsx_reduc_smin_v4sf */

    default:
      return -1;
    }
}

 int
recog_150 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case MULT:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != PLUS
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != MULT
          || GET_MODE (x10) != E_SImode
          || GET_MODE (x6) != E_SImode)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x7, 1);
      if (GET_MODE (x12) != E_SImode)
        return -1;
      x13 = XEXP (x6, 1);
      operands[4] = x13;
      if (!gpc_reg_operand (operands[4], E_SImode))
        return -1;
      x14 = XEXP (x8, 0);
      operands[0] = x14;
      if (!gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x15 = XEXP (x10, 0);
      if (GET_MODE (x15) != E_SImode)
        return -1;
      x16 = XEXP (x10, 1);
      if (GET_MODE (x16) != E_SImode)
        return -1;
      x17 = XEXP (x9, 1);
      if (!rtx_equal_p (x17, operands[4]))
        return -1;
      switch (GET_CODE (x11))
        {
        case ASHIFTRT:
          if (pattern559 (x1, 
ASHIFTRT) != 0)
            return -1;
          switch (GET_CODE (x12))
            {
            case SIGN_EXTEND:
              if (pattern561 (x1, 
SIGN_EXTEND) != 0
                  || !
#line 1274 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 34; /* *macchwc */

            case ASHIFTRT:
              if (pattern562 (x1, 
ASHIFTRT) != 0
                  || !
#line 1340 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 38; /* *machhwc */

            default:
              return -1;
            }

        case LSHIFTRT:
          if (pattern559 (x1, 
LSHIFTRT) != 0)
            return -1;
          switch (GET_CODE (x12))
            {
            case ZERO_EXTEND:
              if (pattern561 (x1, 
ZERO_EXTEND) != 0
                  || !
#line 1306 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 36; /* *macchwuc */

            case LSHIFTRT:
              if (pattern562 (x1, 
LSHIFTRT) != 0
                  || !
#line 1375 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 40; /* *machhwuc */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern560 (x1, 
SIGN_EXTEND) != 0
              || !
#line 1406 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 42; /* *maclhwc */

        case ZERO_EXTEND:
          if (pattern560 (x1, 
ZERO_EXTEND) != 0
              || !
#line 1435 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 44; /* *maclhwuc */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x7;
      x13 = XEXP (x6, 1);
      operands[2] = x13;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          switch (pattern192 (x1, 
PLUS))
            {
            case 0:
              if (!
#line 1872 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 67; /* *addsi3_dot */

            case 1:
              if (!(
#line 1872 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 68; /* *adddi3_dot */

            case 2:
              if (!
#line 1896 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 69; /* *addsi3_dot2 */

            case 3:
              if (!(
#line 1896 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 70; /* *adddi3_dot2 */

            default:
              return -1;
            }

        case CONST_INT:
          if (pnum_clobbers == NULL)
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != SET)
            return -1;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != PLUS)
            return -1;
          x14 = XEXP (x8, 0);
          operands[0] = x14;
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x17 = XEXP (x9, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_SImode:
              if (pattern548 (x9, 
E_SImode) != 0
                  || !
#line 1944 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              *pnum_clobbers = 1;
              return 73; /* *addsi3_imm_dot2 */

            case E_DImode:
              if (pattern548 (x9, 
E_DImode) != 0
                  || !(
#line 1944 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 74; /* *adddi3_imm_dot2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      switch (pattern168 (x1, 
ZERO_EXTEND))
        {
        case 0:
          return 6; /* *zero_extendqisi2_dot */

        case 1:
          return 12; /* *zero_extendhisi2_dot */

        case 2:
          if (!
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 7; /* *zero_extendqidi2_dot */

        case 3:
          if (!
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 13; /* *zero_extendhidi2_dot */

        case 4:
          if (!
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 17; /* *zero_extendsidi2_dot */

        case 5:
          return 8; /* *zero_extendqisi2_dot2 */

        case 6:
          return 14; /* *zero_extendhisi2_dot2 */

        case 7:
          if (!
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 9; /* *zero_extendqidi2_dot2 */

        case 8:
          if (!
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 15; /* *zero_extendhidi2_dot2 */

        case 9:
          if (!
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 18; /* *zero_extendsidi2_dot2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern168 (x1, 
SIGN_EXTEND))
        {
        case 0:
          return 21; /* *extendqisi2_dot */

        case 1:
          return 27; /* *extendhisi2_dot */

        case 2:
          if (!
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 22; /* *extendqidi2_dot */

        case 3:
          if (!
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 28; /* *extendhidi2_dot */

        case 4:
          if (!
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 32; /* *extendsidi2_dot */

        case 5:
          return 23; /* *extendqisi2_dot2 */

        case 6:
          return 29; /* *extendhisi2_dot2 */

        case 7:
          if (!
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 24; /* *extendqidi2_dot2 */

        case 8:
          if (!
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 30; /* *extendhidi2_dot2 */

        case 9:
          if (!
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 33; /* *extendsidi2_dot2 */

        default:
          return -1;
        }

    case PLUS:
      return recog_150 (x1, insn, pnum_clobbers);

    case MINUS:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case MULT:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != SET)
            return -1;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != MINUS
              || GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != MULT
              || GET_MODE (x10) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x11 = XEXP (x4, 0);
          operands[4] = x11;
          if (!gpc_reg_operand (operands[4], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          if (GET_MODE (x12) != E_SImode)
            return -1;
          x13 = XEXP (x7, 1);
          if (GET_MODE (x13) != E_SImode)
            return -1;
          x14 = XEXP (x8, 0);
          operands[0] = x14;
          if (!gpc_reg_operand (operands[0], E_SImode))
            return -1;
          x15 = XEXP (x10, 0);
          if (GET_MODE (x15) != E_SImode)
            return -1;
          x16 = XEXP (x10, 1);
          if (GET_MODE (x16) != E_SImode)
            return -1;
          x17 = XEXP (x9, 0);
          if (!rtx_equal_p (x17, operands[4]))
            return -1;
          switch (GET_CODE (x12))
            {
            case ASHIFTRT:
              x18 = XEXP (x12, 1);
              if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
                  || GET_CODE (x15) != ASHIFTRT)
                return -1;
              x19 = XEXP (x15, 1);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x20 = XEXP (x12, 0);
              if (!gpc_reg_operand (x20, E_SImode))
                return -1;
              switch (GET_CODE (x13))
                {
                case SIGN_EXTEND:
                  if (GET_CODE (x16) != SIGN_EXTEND)
                    return -1;
                  operands[2] = x20;
                  x21 = XEXP (x13, 0);
                  operands[1] = x21;
                  if (!gpc_reg_operand (operands[1], E_HImode))
                    return -1;
                  x22 = XEXP (x15, 0);
                  if (!rtx_equal_p (x22, operands[2]))
                    return -1;
                  x23 = XEXP (x16, 0);
                  if (!rtx_equal_p (x23, operands[1])
                      || !
#line 1466 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 46; /* *nmacchwc */

                case ASHIFTRT:
                  x24 = XEXP (x13, 1);
                  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
                      || GET_CODE (x16) != ASHIFTRT)
                    return -1;
                  x25 = XEXP (x16, 1);
                  if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                    return -1;
                  operands[1] = x20;
                  x21 = XEXP (x13, 0);
                  operands[2] = x21;
                  if (!gpc_reg_operand (operands[2], E_SImode))
                    return -1;
                  x22 = XEXP (x15, 0);
                  if (!rtx_equal_p (x22, operands[1]))
                    return -1;
                  x23 = XEXP (x16, 0);
                  if (!rtx_equal_p (x23, operands[2])
                      || !
#line 1500 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 48; /* *nmachhwc */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              if (GET_CODE (x13) != SIGN_EXTEND
                  || GET_CODE (x15) != SIGN_EXTEND
                  || GET_CODE (x16) != SIGN_EXTEND)
                return -1;
              x20 = XEXP (x12, 0);
              operands[1] = x20;
              if (!gpc_reg_operand (operands[1], E_HImode))
                return -1;
              x21 = XEXP (x13, 0);
              operands[2] = x21;
              if (!gpc_reg_operand (operands[2], E_HImode))
                return -1;
              x22 = XEXP (x15, 0);
              if (!rtx_equal_p (x22, operands[1]))
                return -1;
              x23 = XEXP (x16, 0);
              if (!rtx_equal_p (x23, operands[2])
                  || !
#line 1531 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 50; /* *nmaclhwc */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x7;
          x11 = XEXP (x4, 0);
          operands[2] = x11;
          switch (pattern462 (x1))
            {
            case 0:
              if (!
#line 2215 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 96; /* *subfsi3_dot */

            case 1:
              if (!(
#line 2215 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 97; /* *subfdi3_dot */

            case 2:
              if (!
#line 2239 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 98; /* *subfsi3_dot2 */

            case 3:
              if (!(
#line 2239 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 99; /* *subfdi3_dot2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x11 = XEXP (x4, 0);
      switch (GET_CODE (x11))
        {
        case ASHIFTRT:
          if (pattern420 (x1, 
ASHIFTRT) != 0)
            return -1;
          x7 = XEXP (x4, 1);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              if (pattern557 (x1, 
SIGN_EXTEND) != 0
                  || !
#line 1560 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 52; /* *mulchwc */

            case ASHIFTRT:
              if (pattern558 (x1, 
ASHIFTRT) != 0
                  || !
#line 1620 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 56; /* *mulhhwc */

            default:
              return -1;
            }

        case LSHIFTRT:
          if (pattern420 (x1, 
LSHIFTRT) != 0)
            return -1;
          x7 = XEXP (x4, 1);
          switch (GET_CODE (x7))
            {
            case ZERO_EXTEND:
              if (pattern557 (x1, 
ZERO_EXTEND) != 0
                  || !
#line 1589 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 54; /* *mulchwuc */

            case LSHIFTRT:
              if (pattern558 (x1, 
LSHIFTRT) != 0
                  || !
#line 1652 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 58; /* *mulhhwuc */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern421 (x1, 
SIGN_EXTEND) != 0
              || !
#line 1680 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 60; /* *mullhwc */

        case ZERO_EXTEND:
          if (pattern421 (x1, 
ZERO_EXTEND) != 0
              || !
#line 1706 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 62; /* *mullhwuc */

        case REG:
        case SUBREG:
          switch (pattern193 (x1, 
MULT))
            {
            case 0:
              if (!
#line 3124 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 156; /* *mulsi3_dot */

            case 1:
              if (!(
#line 3124 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 157; /* *muldi3_dot */

            case 2:
              if (!
#line 3149 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 158; /* *mulsi3_dot2 */

            case 3:
              if (!(
#line 3149 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 159; /* *muldi3_dot2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      switch (pattern171 (x1, 
NOT))
        {
        case 0:
          if (!
#line 2132 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 90; /* *one_cmplsi2_dot */

        case 1:
          if (!(
#line 2132 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 91; /* *one_cmpldi2_dot */

        case 2:
          if (!
#line 2153 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 92; /* *one_cmplsi2_dot2 */

        case 3:
          if (!(
#line 2153 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 93; /* *one_cmpldi2_dot2 */

        default:
          return -1;
        }

    case NEG:
      switch (pattern171 (x1, 
NEG))
        {
        case 0:
          if (!
#line 2410 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 118; /* *negsi2_dot */

        case 1:
          if (!(
#line 2410 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 119; /* *negdi2_dot */

        case 2:
          if (!
#line 2431 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 120; /* *negsi2_dot2 */

        case 3:
          if (!(
#line 2431 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 121; /* *negdi2_dot2 */

        default:
          return -1;
        }

    case DIV:
      if (pattern172 (x1, pnum_clobbers, 
DIV) != 0
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x11 = XEXP (x4, 0);
      operands[1] = x11;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      x14 = XEXP (x8, 0);
      operands[0] = x14;
      x9 = XEXP (x8, 1);
      x17 = XEXP (x9, 0);
      if (!rtx_equal_p (x17, operands[1]))
        return -1;
      x10 = XEXP (x9, 1);
      if (!rtx_equal_p (x10, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (pattern542 (x9, 
E_SImode) != 0
              || !
#line 3420 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 185; /* *divsi3_sra_dot2 */

        case E_DImode:
          if (pattern542 (x9, 
E_DImode) != 0
              || !(
#line 3420 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 186; /* *divdi3_sra_dot2 */

        default:
          return -1;
        }

    case AND:
    case IOR:
    case XOR:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      if (!cc_reg_operand (x6, E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return -1;
      if (GET_CODE (x4) == AND)
        {
          res = recog_149 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[4] = x6;
      switch (pattern372 (x1))
        {
        case 0:
          if (!
#line 4016 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 217; /* *boolsi3_dot */

        case 1:
          if (!(
#line 4016 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 218; /* *booldi3_dot */

        case 2:
          if (!
#line 4039 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 219; /* *boolsi3_dot2 */

        case 3:
          if (!(
#line 4039 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 220; /* *booldi3_dot2 */

        case 4:
          if (!
#line 4071 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 223; /* *boolcsi3_dot */

        case 5:
          if (!(
#line 4071 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 224; /* *boolcdi3_dot */

        case 6:
          if (!
#line 4094 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 225; /* *boolcsi3_dot2 */

        case 7:
          if (!(
#line 4094 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 226; /* *boolcdi3_dot2 */

        case 8:
          if (!
#line 4126 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 229; /* *boolccsi3_dot */

        case 9:
          if (!(
#line 4126 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 230; /* *boolccdi3_dot */

        case 10:
          if (!
#line 4149 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 231; /* *boolccsi3_dot2 */

        case 11:
          if (!(
#line 4149 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 232; /* *boolccdi3_dot2 */

        default:
          return -1;
        }

    case ROTATE:
      switch (pattern174 (x1, 
ROTATE))
        {
        case 0:
          if (!
#line 4590 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 267; /* *rotlsi3_dot */

        case 1:
          if (!(
#line 4590 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 268; /* *rotldi3_dot */

        case 2:
          if (!
#line 4615 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 269; /* *rotlsi3_dot2 */

        case 3:
          if (!(
#line 4615 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 270; /* *rotldi3_dot2 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern175 (x1))
        {
        case 0:
          if (!
#line 4658 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 274; /* *ashlsi3_dot */

        case 1:
          if (!(
#line 4658 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 275; /* *ashldi3_dot */

        case 2:
          if (!
#line 4683 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 276; /* *ashlsi3_dot2 */

        case 3:
          if (!(
#line 4683 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 277; /* *ashldi3_dot2 */

        case 4:
          if (!
#line 4732 "../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI))
            return -1;
          return 279; /* ashdi3_extswsli_dot */

        case 5:
          if (!
#line 4782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI))
            return -1;
          return 280; /* ashdi3_extswsli_dot2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern174 (x1, 
LSHIFTRT))
        {
        case 0:
          if (!
#line 4847 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 284; /* *lshrsi3_dot */

        case 1:
          if (!(
#line 4847 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 285; /* *lshrdi3_dot */

        case 2:
          if (!
#line 4872 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 286; /* *lshrsi3_dot2 */

        case 3:
          if (!(
#line 4872 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 287; /* *lshrdi3_dot2 */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pattern172 (x1, pnum_clobbers, 
ASHIFTRT) != 0
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x11 = XEXP (x4, 0);
      operands[1] = x11;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (!reg_or_cint_operand (operands[2], E_SImode))
        return -1;
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 4945 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 293; /* *ashrsi3_dot2 */

        case 1:
          if (!(
#line 4945 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 294; /* *ashrdi3_dot2 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x6 = XEXP (x2, 0);
      operands[2] = x6;
      if (!cc_reg_operand (operands[2], E_CCmode))
        return -1;
      switch (pattern422 (x1))
        {
        case 0:
          if (!
#line 513 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64))
            return -1;
          return 563; /* *movsi_internal2 */

        case 1:
          if (!
#line 513 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 564; /* *movdi_internal2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern176 (x1, 
CLOBBER, 
E_CCFPmode) != 0
          || GET_MODE (x3) != E_CCFPmode
          || GET_MODE (x4) != E_V2DFmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (!zero_constant (x5, E_V2DFmode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x14 = XEXP (x8, 0);
      operands[0] = x14;
      switch (XVECLEN (x4, 0))
        {
        case 3:
          x26 = XVECEXP (x4, 0, 0);
          operands[1] = x26;
          x27 = XVECEXP (x4, 0, 1);
          operands[2] = x27;
          x28 = XVECEXP (x4, 0, 2);
          operands[3] = x28;
          if (!const_0_to_1_operand (operands[3], E_QImode))
            return -1;
          operands[4] = x5;
          switch (XINT (x4, 1))
            {
            case 342:
              switch (pattern549 ())
                {
                case 0:
                  if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2188; /* *bcdadd_test_v1ti */

                case 1:
                  if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2190; /* *bcdadd_test_v16qi */

                default:
                  return -1;
                }

            case 343:
              switch (pattern549 ())
                {
                case 0:
                  if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2189; /* *bcdsub_test_v1ti */

                case 1:
                  if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2191; /* *bcdsub_test_v16qi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          if (XINT (x4, 1) != 343)
            return -1;
          x26 = XVECEXP (x4, 0, 0);
          operands[1] = x26;
          operands[2] = x5;
          switch (GET_MODE (operands[1]))
            {
            case E_V1TImode:
              if (!register_operand (operands[1], E_V1TImode)
                  || !scratch_operand (operands[0], E_V1TImode)
                  || !
#line 4737 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2204; /* *bcdinvalid_v1ti */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !scratch_operand (operands[0], E_V16QImode)
                  || !
#line 4737 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2205; /* *bcdinvalid_v16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MEM:
      switch (pattern180 (x1))
        {
        case 0:
          if (!
#line 28 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2360; /* *ld_cmpdi_cr0_DI_clobber_CC_none */

        case 1:
          if (!
#line 112 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2364; /* *lwz_cmpwi_cr0_SI_clobber_CC_none */

        case 2:
          if (!
#line 239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2370; /* *lha_cmpdi_cr0_HI_clobber_CC_sign */

        case 3:
          if (!(
#line 239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2371; /* *lha_cmpdi_cr0_HI_clobber_CC_sign */

        case 4:
          if (!
#line 49 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2361; /* *ld_cmpldi_cr0_DI_clobber_CCUNS_none */

        case 5:
          if (!
#line 133 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2365; /* *lwz_cmpldi_cr0_SI_clobber_CCUNS_none */

        case 6:
          if (!
#line 260 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2372; /* *lhz_cmpldi_cr0_HI_clobber_CCUNS_zero */

        case 7:
          if (!(
#line 260 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2373; /* *lhz_cmpldi_cr0_HI_clobber_CCUNS_zero */

        case 8:
          if (!
#line 323 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2378; /* *lbz_cmpldi_cr0_QI_clobber_CCUNS_zero */

        case 9:
          if (!(
#line 323 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2379; /* *lbz_cmpldi_cr0_QI_clobber_CCUNS_zero */

        case 10:
          if (!
#line 70 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2362; /* *ld_cmpdi_cr0_DI_DI_CC_none */

        case 11:
          if (!
#line 154 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2366; /* *lwz_cmpwi_cr0_SI_SI_CC_none */

        case 12:
          if (!
#line 91 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2363; /* *ld_cmpldi_cr0_DI_DI_CCUNS_none */

        case 13:
          if (!
#line 175 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2367; /* *lwz_cmpldi_cr0_SI_SI_CCUNS_none */

        case 14:
          if (!(
#line 196 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2368; /* *lwa_cmpdi_cr0_SI_EXTSI_CC_sign */

        case 15:
          if (!
#line 281 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2374; /* *lha_cmpdi_cr0_HI_EXTHI_CC_sign */

        case 16:
          if (!(
#line 281 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2375; /* *lha_cmpdi_cr0_HI_EXTHI_CC_sign */

        case 17:
          if (!(
#line 218 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2369; /* *lwz_cmpldi_cr0_SI_EXTSI_CCUNS_zero */

        case 18:
          if (!
#line 302 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2376; /* *lhz_cmpldi_cr0_HI_EXTHI_CCUNS_zero */

        case 19:
          if (!(
#line 302 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2377; /* *lhz_cmpldi_cr0_HI_EXTHI_CCUNS_zero */

        case 20:
          if (!
#line 344 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2380; /* *lbz_cmpldi_cr0_QI_GPR_CCUNS_zero */

        case 21:
          if (!(
#line 344 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2381; /* *lbz_cmpldi_cr0_QI_GPR_CCUNS_zero */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_179 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case EQ:
    case GE:
    case GT:
      operands[1] = x4;
      if (fpmask_comparison_operator (operands[1], E_CCFPmode))
        {
          switch (pattern292 (x1))
            {
            case 0:
              if (
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 370; /* *movsfsfcc_p9 */
              break;

            case 1:
              if (
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 372; /* *movsfdfcc_p9 */
              break;

            case 2:
              if (
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 371; /* *movdfsfcc_p9 */
              break;

            case 3:
              if (
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 373; /* *movdfdfcc_p9 */
              break;

            case 4:
              if ((
#line 5770 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return 382; /* *movkfcc_p10 */
              break;

            case 5:
              if ((
#line 5770 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return 383; /* *movtfcc_p10 */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL
          || pattern250 (x1, 
EQ) != 0)
        return -1;
      *pnum_clobbers = 2;
      return 909; /* bdz_di */

    case NE:
    case UNLE:
    case UNLT:
      operands[1] = x4;
      if (invert_fpmask_comparison_operator (operands[1], E_CCFPmode))
        {
          switch (pattern292 (x1))
            {
            case 0:
              if (
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 374; /* *movsfsfcc_invert_p9 */
              break;

            case 1:
              if (
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 376; /* *movsfdfcc_invert_p9 */
              break;

            case 2:
              if (
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 375; /* *movdfsfcc_invert_p9 */
              break;

            case 3:
              if (
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 377; /* *movdfdfcc_invert_p9 */
              break;

            case 4:
              if ((
#line 5802 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return 384; /* *movkfcc_invert_p10 */
              break;

            case 5:
              if ((
#line 5802 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return 385; /* *movtfcc_invert_p10 */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL
          || pattern250 (x1, 
NE) != 0)
        return -1;
      *pnum_clobbers = 2;
      return 910; /* bdnz_di */

    case AND:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 1);
      if (!branch_comparison_operator (x5, E_VOIDmode))
        return -1;
      operands[3] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x8 = XEXP (x3, 2);
      if (GET_CODE (x8) != PC
          || pattern396 (x1) != 0)
        return -1;
      x9 = XEXP (x5, 0);
      operands[4] = x9;
      if (!cc_reg_operand (operands[4], E_VOIDmode))
        return -1;
      x10 = XEXP (x7, 0);
      operands[0] = x10;
      x11 = XVECEXP (x1, 0, 1);
      x12 = XEXP (x11, 0);
      operands[2] = x12;
      if (!nonimmediate_operand (operands[2], E_DImode))
        return -1;
      switch (pattern555 (x1))
        {
        case 0:
          *pnum_clobbers = 3;
          return 911; /* bdztf_di */

        case 1:
          *pnum_clobbers = 3;
          return 912; /* bdnztf_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_186 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != USE)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  if (!symbol_ref_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x5, 0);
  operands[2] = x7;
  x8 = XEXP (x5, 1);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x9))
    {
    case CLOBBER:
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 96
          || GET_MODE (x10) != E_DImode)
        return -1;
      switch (REGNO (x4))
        {
        case 11:
          switch (GET_MODE (operands[2]))
            {
            case E_DImode:
              if (memory_operand (operands[2], E_DImode)
                  && gpc_reg_operand (operands[3], E_DImode))
                return 920; /* *save_gpregs_di_r11 */
              if (!gpc_reg_operand (operands[2], E_DImode)
                  || !memory_operand (operands[3], E_DImode))
                return -1;
              return 930; /* *restore_gpregs_di_r11 */

            case E_DFmode:
              if (!memory_operand (operands[2], E_DFmode)
                  || !gpc_reg_operand (operands[3], E_DFmode))
                return -1;
              return 923; /* *save_fpregs_di_r11 */

            default:
              return -1;
            }

        case 12:
          switch (GET_MODE (operands[2]))
            {
            case E_DImode:
              if (memory_operand (operands[2], E_DImode)
                  && gpc_reg_operand (operands[3], E_DImode))
                return 921; /* *save_gpregs_di_r12 */
              if (!gpc_reg_operand (operands[2], E_DImode)
                  || !memory_operand (operands[3], E_DImode))
                return -1;
              return 931; /* *restore_gpregs_di_r12 */

            case E_DFmode:
              if (!memory_operand (operands[2], E_DFmode)
                  || !gpc_reg_operand (operands[3], E_DFmode))
                return -1;
              return 924; /* *save_fpregs_di_r12 */

            default:
              return -1;
            }

        case 1:
          switch (GET_MODE (operands[2]))
            {
            case E_DImode:
              if (memory_operand (operands[2], E_DImode)
                  && gpc_reg_operand (operands[3], E_DImode))
                return 922; /* *save_gpregs_di_r1 */
              if (!gpc_reg_operand (operands[2], E_DImode)
                  || !memory_operand (operands[3], E_DImode))
                return -1;
              return 932; /* *restore_gpregs_di_r1 */

            case E_DFmode:
              if (!memory_operand (operands[2], E_DFmode)
                  || !gpc_reg_operand (operands[3], E_DFmode))
                return -1;
              return 925; /* *save_fpregs_di_r1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case RETURN:
      if (!gpc_reg_operand (operands[2], E_DFmode)
          || !memory_operand (operands[3], E_DFmode))
        return -1;
      switch (REGNO (x4))
        {
        case 11:
          return 939; /* *return_and_restore_fpregs_aix_di_r11 */

        case 1:
          return 940; /* *return_and_restore_fpregs_aix_di_r1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern73 (x1))
    {
    case 0:
      if (!(
#line 5879 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFIDS && can_create_pseudo_p ()) && 
#line 5882 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_173 (insn, operands);

    case 1:
      if (memory_operand (operands[1], E_DImode)
          && scratch_operand (operands[2], E_DImode)
          && (
#line 7048 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS) && 
#line 7050 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_227 (insn, operands);
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !scratch_operand (operands[2], E_DFmode)
          || !(
#line 7068 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FCFID && TARGET_HARD_FLOAT && !TARGET_FCFIDS) && 
#line 7070 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_228 (insn, operands);

    case 2:
      if (!(
#line 5879 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFID && can_create_pseudo_p ()) && 
#line 5882 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_174 (insn, operands);

    case 3:
      if (!(
#line 6975 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID) && 
#line 6977 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_225 (insn, operands);

    case 4:
      if (!((
#line 15328 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15330 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_504 (insn, operands);

    case 5:
      if (!((
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15349 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_506 (insn, operands);

    case 6:
      if (!((
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15349 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_507 (insn, operands);

    case 7:
      if (!((
#line 15328 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15330 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_505 (insn, operands);

    case 8:
      if (!((
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15349 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_508 (insn, operands);

    case 9:
      if (!((
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15349 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_509 (insn, operands);

    case 10:
      if (!(
#line 5920 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFIDS) && 
#line 5922 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_175 (insn, operands);

    case 11:
      if (!(
#line 5920 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFID) && 
#line 5922 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_176 (insn, operands);

    case 12:
      if (!(
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT) && 
#line 5947 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_177 (insn, operands);

    case 13:
      if (!(
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT) && 
#line 5947 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_178 (insn, operands);

    case 14:
      if (!(
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT) && 
#line 5947 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_179 (insn, operands);

    case 15:
      if (!(
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT) && 
#line 5947 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_180 (insn, operands);

    case 16:
      if (const_0_to_3_operand (operands[2], E_QImode)
          && scratch_operand (operands[3], E_V4SImode)
          && (
#line 4437 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4439 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_621 (insn, operands);
      if (!const_int_operand (operands[2], E_QImode)
          || !scratch_operand (operands[3], E_SImode)
          || !(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_640 (insn, operands);

    case 17:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_632 (insn, operands);

    case 18:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_636 (insn, operands);

    case 19:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_631 (insn, operands);

    case 20:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_635 (insn, operands);

    case 21:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_639 (insn, operands);

    case 22:
      if (!((
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_633 (insn, operands);

    case 23:
      if (!((
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_637 (insn, operands);

    case 24:
      if (!((
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_641 (insn, operands);

    case 25:
      if (!((
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_634 (insn, operands);

    case 26:
      if (!((
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_638 (insn, operands);

    case 27:
      if (!((
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_642 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return NULL;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return NULL;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case FLOAT:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern297 (x1))
        {
        case 0:
          if (!(
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6219 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_187 (insn, operands);

        case 1:
          if (!(
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6219 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_188 (insn, operands);

        case 2:
          if (!(
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6219 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_189 (insn, operands);

        case 3:
          if (!(
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6219 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_190 (insn, operands);

        default:
          return NULL;
        }

    case EQ:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern108 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_401 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_421 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_411 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_431 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x9 = XEXP (x5, 1);
      operands[2] = x9;
      x10 = XEXP (x6, 0);
      operands[3] = x10;
      x11 = XEXP (x3, 0);
      operands[4] = x11;
      x12 = XEXP (x4, 0);
      operands[5] = x12;
      switch (pattern507 (x5))
        {
        case 0:
          if ((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return gen_split_402 (insn, operands);
          break;

        case 1:
          if (((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return gen_split_422 (insn, operands);
          break;

        case 2:
          if (reg_or_short_operand (operands[2], E_SImode)
              && scratch_operand (operands[3], E_DImode)
              && scratch_operand (operands[4], E_DImode)
              && scratch_operand (operands[5], E_CCmode)
              && ((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return gen_split_412 (insn, operands);
          if (scc_eq_operand (operands[2], E_SImode)
              && scratch_operand (operands[3], E_SImode)
              && scratch_operand (operands[4], E_SImode)
              && scratch_operand (operands[5], E_DImode)
              && ((
#line 13248 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_ISEL) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13250 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return gen_split_451 (insn, operands);
          break;

        case 3:
          if (((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return gen_split_432 (insn, operands);
          break;

        default:
          break;
        }
      if (!scratch_operand (operands[4], E_DImode)
          || pattern508 (x1) != 0
          || !((
#line 12993 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 12995 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_443 (insn, operands);

    case LT:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern108 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_403 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_423 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_413 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_433 (insn, operands);

        default:
          return NULL;
        }

    case LTU:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern111 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_404 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_424 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_414 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_434 (insn, operands);

        default:
          return NULL;
        }

    case GT:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern108 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_405 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_425 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_415 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_435 (insn, operands);

        default:
          return NULL;
        }

    case GTU:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern111 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_406 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_426 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_416 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_436 (insn, operands);

        default:
          return NULL;
        }

    case LE:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern108 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_407 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_427 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_417 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_437 (insn, operands);

        default:
          return NULL;
        }

    case LEU:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern111 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_408 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_428 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_418 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_438 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern108 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_409 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_429 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_419 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_439 (insn, operands);

        default:
          return NULL;
        }

    case GEU:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern111 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_410 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_430 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_420 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_440 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      if (GET_MODE (x5) != E_DImode)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern339 (x1))
        {
        case 0:
          if (!((
#line 13026 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 13028 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_444 (insn, operands);

        case 1:
          if (!((
#line 13058 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 13060 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_445 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      if (GET_MODE (x5) != E_DImode)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern340 (x1))
        {
        case 0:
          return gen_split_446 (insn, operands);

        case 1:
          return gen_split_447 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      if (GET_MODE (x5) != E_DImode)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern341 (x1))
        {
        case 0:
          return gen_split_448 (insn, operands);

        case 1:
          return gen_split_449 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      x8 = XEXP (x5, 0);
      if (!comparison_operator (x8, E_VOIDmode))
        return NULL;
      operands[2] = x8;
      x13 = XEXP (x8, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern396 (x1) != 0)
        return NULL;
      x14 = XEXP (x8, 0);
      operands[1] = x14;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return NULL;
      x9 = XEXP (x5, 1);
      operands[5] = x9;
      x15 = XEXP (x5, 2);
      operands[6] = x15;
      x6 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x6, 0);
      operands[0] = x10;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return NULL;
      x11 = XEXP (x3, 0);
      operands[3] = x11;
      if (!scratch_operand (operands[3], E_CCmode))
        return NULL;
      x12 = XEXP (x4, 0);
      operands[4] = x12;
      if (!scratch_operand (operands[4], E_DImode))
        return NULL;
      x16 = XEXP (x6, 1);
      x17 = XEXP (x16, 0);
      if (!rtx_equal_p (x17, operands[1])
          || !(
#line 13768 "../../gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return NULL;
      return gen_split_474 (insn, operands);

    case VEC_SELECT:
      if (GET_MODE (x5) != E_SFmode)
        return NULL;
      x9 = XEXP (x5, 1);
      if (GET_CODE (x9) != PARALLEL
          || XVECLEN (x9, 0) != 1)
        return NULL;
      x18 = XVECEXP (x9, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern460 (x1))
        {
        case 0:
          if (!(
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 5026 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_668 (insn, operands);

        case 1:
          if (!(
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 5026 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_669 (insn, operands);

        case 2:
          if (!(
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 5026 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_670 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
