/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SFmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 2)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != CONST_INT
      || !vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  return pattern6 (x3, 
E_V4SFmode); /* [-1, 1] */
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != COMPARE
      || GET_MODE (x3) != E_CCFPmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x2, 0);
  operands[0] = x13;
  if (!cc_reg_operand (operands[0], E_CCFPmode))
    return -1;
  x14 = XEXP (x3, 0);
  operands[1] = x14;
  x15 = XEXP (x3, 1);
  operands[2] = x15;
  x16 = XEXP (x4, 0);
  operands[3] = x16;
  if (!scratch_operand (operands[3], E_DFmode))
    return -1;
  x17 = XEXP (x5, 0);
  operands[4] = x17;
  if (!scratch_operand (operands[4], E_DFmode))
    return -1;
  x18 = XEXP (x6, 0);
  operands[5] = x18;
  if (!scratch_operand (operands[5], E_DFmode))
    return -1;
  x19 = XEXP (x7, 0);
  operands[6] = x19;
  if (!scratch_operand (operands[6], E_DFmode))
    return -1;
  x20 = XEXP (x8, 0);
  operands[7] = x20;
  if (!scratch_operand (operands[7], E_DFmode))
    return -1;
  x21 = XEXP (x9, 0);
  operands[8] = x21;
  if (!scratch_operand (operands[8], E_DFmode))
    return -1;
  x22 = XEXP (x10, 0);
  operands[9] = x22;
  if (!scratch_operand (operands[9], E_DFmode))
    return -1;
  x23 = XEXP (x11, 0);
  operands[10] = x23;
  if (!scratch_operand (operands[10], E_DFmode))
    return -1;
  x24 = XEXP (x12, 0);
  operands[11] = x24;
  switch (GET_MODE (operands[1]))
    {
    case E_IFmode:
      return pattern17 (
E_IFmode); /* [-1, 1] */

    case E_TFmode:
      res = pattern17 (
E_TFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern52 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern59 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern37 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern37 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern55 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern55 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern55 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern55 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern55 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern55 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern55 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern55 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern55 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern55 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      res = pattern58 (x1);
      if (res >= 0)
        return res + 12; /* [12, 23] */
      return -1;

    default:
      return -1;
    }
}

int
pattern77 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      return 0;

    case E_QImode:
      if (GET_MODE (x5) != E_QImode)
        return -1;
      return 1;

    case E_HImode:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  return pattern84 (x1); /* [-1, 1] */
}

int
pattern90 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !exact_log2_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern100 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_SImode)
    return -1;
  switch (GET_CODE (x7))
    {
    case FIX:
      return pattern96 (x1); /* [-1, 1] */

    case VEC_SELECT:
      res = pattern97 (x1);
      if (res >= 0)
        return res + 2; /* [2, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern105 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SFmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 102
      || GET_MODE (x4) != E_V4SFmode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!vfloat_operand (operands[0], E_V4SFmode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[1] = x9;
  if (!vfloat_operand (operands[1], E_V4SFmode))
    return -1;
  x10 = XEXP (x6, 0);
  operands[2] = x10;
  if (!scratch_operand (operands[2], E_V4SFmode))
    return -1;
  x11 = XEXP (x7, 0);
  operands[3] = x11;
  if (!scratch_operand (operands[3], E_V4SFmode))
    return -1;
  return 0;
}

int
pattern116 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern123 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern122 (x1, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern122 (x1, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern132 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern131 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern131 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern140 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!altivec_register_operand (operands[0], E_V16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!altivec_register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern159 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_12_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern141 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern141 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern141 (x3, 
E_V1TImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern166 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case VEC_CONCAT:
      if (GET_MODE (x5) != E_V2DFmode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != VEC_SELECT
          || GET_MODE (x6) != E_DFmode)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x5, 1);
      if (GET_CODE (x9) != VEC_SELECT
          || GET_MODE (x9) != E_DFmode)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x11 = XVECEXP (x10, 0, 0);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || XWINT (x3, 0) != 1L
          || !vfloat_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || GET_MODE (x4) != E_V2DFmode)
        return -1;
      x12 = XEXP (x6, 0);
      operands[1] = x12;
      if (!vfloat_operand (operands[1], E_V2DFmode))
        return -1;
      x13 = XEXP (x9, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XEXP (x4, 1);
      if (!rtx_equal_p (x14, operands[1]))
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 102
          || GET_MODE (x5) != E_V4SFmode)
        return -1;
      x15 = XVECEXP (x5, 0, 0);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || XWINT (x3, 0) != 3L
          || !vfloat_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || GET_MODE (x4) != E_V4SFmode)
        return -1;
      x14 = XEXP (x4, 1);
      operands[1] = x14;
      if (!vfloat_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern190 (rtx x1, rtx_code i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  return 0;
}

int
pattern196 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern201 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!altivec_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern212 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x1) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    case E_V4SFmode:
      if (GET_MODE (x1) != E_V4SFmode)
        return -1;
      return 4;

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern228 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern234 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  return pattern233 (x1); /* [-1, 23] */
}

int
pattern237 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern229 (x4, 
i1); /* [-1, 0] */
}

int
pattern245 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case NOT:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x7, 1);
      switch (GET_CODE (x10))
        {
        case NOT:
          return pattern243 (x6); /* [-1, 23] */

        case REG:
        case SUBREG:
          res = pattern239 (x6);
          if (res >= 0)
            return res + 24; /* [24, 47] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern234 (x6);
      if (res >= 0)
        return res + 48; /* [48, 71] */
      return -1;

    default:
      return -1;
    }
}

int
pattern255 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern257 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern256 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern256 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern263 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern261 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern261 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern262 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern262 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern262 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern262 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern262 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern262 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern262 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern262 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern262 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern262 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern280 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern266 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern266 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern287 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 98)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  return 0;
}

int
pattern296 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!reg_or_indexed_operand (operands[1], E_QImode)
          || !scratch_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!reg_or_indexed_operand (operands[1], E_HImode)
          || !scratch_operand (operands[4], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern305 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern316 (int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!altivec_register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_QImode:
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 2;

    case E_HImode:
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern331 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern339 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 98
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  return pattern338 (x7); /* [-1, 1] */
}

int
pattern347 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!int_reg_operand (operands[0], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!cc_reg_operand (operands[2], E_CCmode))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  return 0;
}

int
pattern355 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vlogical_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vlogical_operand (operands[1], i1)
      || !vlogical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern360 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern370 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern380 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern378 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern378 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern379 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern379 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern379 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern379 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern379 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern379 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern379 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern379 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern379 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern379 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern395 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V2DFmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_CONCAT
      || GET_MODE (x5) != E_V2DFmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT
      || GET_MODE (x6) != E_DFmode)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL
      || XVECLEN (x7, 0) != 1)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XEXP (x5, 1);
  if (GET_CODE (x9) != VEC_SELECT
      || GET_MODE (x9) != E_DFmode)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PARALLEL
      || XVECLEN (x10, 0) != 1)
    return -1;
  x11 = XVECEXP (x10, 0, 0);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x12 = XEXP (x3, 1);
  x13 = XVECEXP (x12, 0, 0);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || pattern394 (x1) != 0)
    return -1;
  return 0;
}

int
pattern407 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern413 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_OOmode:
      if (!vsx_register_operand (operands[1], E_OOmode)
          || !const_0_to_1_operand (operands[2], E_VOIDmode))
        return -1;
      return 0;

    case E_XOmode:
      if (!fpr_reg_operand (operands[1], E_XOmode)
          || !const_0_to_3_operand (operands[2], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern422 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern433 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern438 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern448 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], E_V4SFmode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 2);
  if (!const_0_to_3_operand (x4, E_QImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (!scratch_operand (x6, E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[2] = x7;
      if (!gpc_reg_operand (operands[2], E_SFmode))
        return -1;
      operands[3] = x4;
      operands[4] = x6;
      return 0;

    case CONST_DOUBLE:
      operands[2] = x7;
      if (!zero_fp_constant (operands[2], E_SFmode))
        return -1;
      operands[3] = x4;
      operands[4] = x6;
      return 1;

    case VEC_SELECT:
      if (GET_MODE (x7) != E_SFmode)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      if (!gpc_reg_operand (operands[2], E_V4SFmode))
        return -1;
      x10 = XVECEXP (x8, 0, 0);
      operands[3] = x10;
      if (!const_0_to_3_operand (operands[3], E_QImode))
        return -1;
      operands[4] = x4;
      operands[5] = x6;
      return 2;

    default:
      return -1;
    }
}

int
pattern471 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !logical_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern477 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[1], E_V2DImode)
      || !vsx_register_operand (operands[3], i1)
      || !vsx_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern480 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[4], i1)
      || !vsx_register_operand (operands[5], i1))
    return -1;
  return pattern479 (); /* [-1, 1] */
}

int
pattern486 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode)
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode)
        return -1;
      return 1;

    case E_KFmode:
      if (!register_operand (operands[0], E_KFmode)
          || GET_MODE (x1) != E_KFmode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern497 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern506 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern513 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fpr_reg_operand (operands[1], E_XOmode)
      || !vsx_register_operand (operands[2], E_OOmode)
      || !vsx_register_operand (operands[3], E_V16QImode)
      || !const_0_to_3_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern519 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern530 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern535 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern543 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_aligned_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern551 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern559 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != i1)
    return -1;
  x12 = XEXP (x11, 1);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x13 = XEXP (x6, 0);
  if (!gpc_reg_operand (x13, E_SImode))
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern308 (x2, 
E_SImode) != 0)
            return -1;
          return 233; /* *eqvsi3 */

        case E_DImode:
          if (pattern308 (x2, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 234; /* *eqvdi3 */

        case E_TImode:
          if (GET_MODE (x2) != E_TImode
              || GET_MODE (x3) != E_TImode)
            return -1;
          if (vlogical_operand (operands[0], E_TImode)
              && vlogical_operand (operands[1], E_TImode)
              && vlogical_operand (operands[2], E_TImode)
              && 
#line 7572 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))
            return 536; /* *eqvti3_internal1 */
          if (!int_reg_operand (operands[0], E_TImode)
              || !int_reg_operand (operands[1], E_TImode)
              || !int_reg_operand (operands[2], E_TImode)
              || !
#line 7609 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR))
            return -1;
          return 545; /* *eqvti3_internal2 */

        case E_PTImode:
          if (GET_MODE (x2) != E_PTImode
              || GET_MODE (x3) != E_PTImode)
            return -1;
          if (vlogical_operand (operands[0], E_PTImode)
              && vlogical_operand (operands[1], E_PTImode)
              && vlogical_operand (operands[2], E_PTImode)
              && 
#line 7572 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))
            return 537; /* *eqvpti3_internal1 */
          if (!int_reg_operand (operands[0], E_PTImode)
              || !int_reg_operand (operands[1], E_PTImode)
              || !int_reg_operand (operands[2], E_PTImode)
              || !
#line 7609 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR))
            return -1;
          return 546; /* *eqvpti3_internal2 */

        case E_V16QImode:
          if (pattern300 (x2, 
E_V16QImode) != 0
              || !(
#line 7572 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 538; /* *eqvv16qi3_internal1 */

        case E_V8HImode:
          if (pattern300 (x2, 
E_V8HImode) != 0
              || !(
#line 7572 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 539; /* *eqvv8hi3_internal1 */

        case E_V4SImode:
          if (pattern300 (x2, 
E_V4SImode) != 0
              || !(
#line 7572 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 540; /* *eqvv4si3_internal1 */

        case E_V4SFmode:
          if (pattern300 (x2, 
E_V4SFmode) != 0
              || !(
#line 7572 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 541; /* *eqvv4sf3_internal1 */

        case E_V2DImode:
          if (pattern300 (x2, 
E_V2DImode) != 0
              || !(
#line 7572 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 542; /* *eqvv2di3_internal1 */

        case E_V2DFmode:
          if (pattern300 (x2, 
E_V2DFmode) != 0
              || !(
#line 7572 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 543; /* *eqvv2df3_internal1 */

        case E_V1TImode:
          if (pattern300 (x2, 
E_V1TImode) != 0
              || !(
#line 7572 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 544; /* *eqvv1ti3_internal1 */

        default:
          return -1;
        }

    case AND:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          switch (pattern263 (x2))
            {
            case 0:
              if (!
#line 691 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2418; /* *fuse_and_eqv */

            case 1:
              if (!(
#line 691 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2419; /* *fuse_and_eqv */

            case 2:
              if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2710; /* *fuse_vand_veqv */

            case 3:
              if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2711; /* *fuse_vand_veqv */

            case 4:
              if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2712; /* *fuse_vand_veqv */

            case 5:
              if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2713; /* *fuse_vand_veqv */

            case 6:
              if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2714; /* *fuse_vand_veqv */

            case 7:
              if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2715; /* *fuse_vand_veqv */

            case 8:
              if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2716; /* *fuse_vand_veqv */

            case 9:
              if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2717; /* *fuse_vand_veqv */

            case 10:
              if (!(
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2718; /* *fuse_vand_veqv */

            case 11:
              if (!(
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2719; /* *fuse_vand_veqv */

            default:
              return -1;
            }

        case NOT:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x9 = XEXP (x5, 1);
          switch (GET_CODE (x9))
            {
            case REG:
            case SUBREG:
              switch (pattern402 (x2))
                {
                case 0:
                  if (!
#line 709 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2420; /* *fuse_andc_eqv */

                case 1:
                  if (!(
#line 709 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2421; /* *fuse_andc_eqv */

                case 2:
                  if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2720; /* *fuse_vandc_veqv */

                case 3:
                  if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2721; /* *fuse_vandc_veqv */

                case 4:
                  if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2722; /* *fuse_vandc_veqv */

                case 5:
                  if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2723; /* *fuse_vandc_veqv */

                case 6:
                  if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2724; /* *fuse_vandc_veqv */

                case 7:
                  if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2725; /* *fuse_vandc_veqv */

                case 8:
                  if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2726; /* *fuse_vandc_veqv */

                case 9:
                  if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2727; /* *fuse_vandc_veqv */

                case 10:
                  if (!(
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2728; /* *fuse_vandc_veqv */

                case 11:
                  if (!(
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2729; /* *fuse_vandc_veqv */

                default:
                  return -1;
                }

            case NOT:
              switch (pattern405 (x2))
                {
                case 0:
                  if (!
#line 763 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2426; /* *fuse_nor_eqv */

                case 1:
                  if (!(
#line 763 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2427; /* *fuse_nor_eqv */

                case 2:
                  if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2750; /* *fuse_vnor_veqv */

                case 3:
                  if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2751; /* *fuse_vnor_veqv */

                case 4:
                  if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2752; /* *fuse_vnor_veqv */

                case 5:
                  if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2753; /* *fuse_vnor_veqv */

                case 6:
                  if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2754; /* *fuse_vnor_veqv */

                case 7:
                  if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2755; /* *fuse_vnor_veqv */

                case 8:
                  if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2756; /* *fuse_vnor_veqv */

                case 9:
                  if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2757; /* *fuse_vnor_veqv */

                case 10:
                  if (!(
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2758; /* *fuse_vnor_veqv */

                case 11:
                  if (!(
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2759; /* *fuse_vnor_veqv */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != XOR)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      x10 = XEXP (x7, 1);
      operands[1] = x10;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern431 (x2, 
E_SImode) != 0
              || !
#line 727 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2422; /* *fuse_eqv_eqv */

        case E_DImode:
          if (pattern431 (x2, 
E_DImode) != 0
              || !(
#line 727 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2423; /* *fuse_eqv_eqv */

        case E_V4SImode:
          if (pattern432 (x2, 
E_V4SImode) != 0
              || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2730; /* *fuse_veqv_veqv */

        case E_V8HImode:
          if (pattern432 (x2, 
E_V8HImode) != 0
              || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2731; /* *fuse_veqv_veqv */

        case E_V16QImode:
          if (pattern432 (x2, 
E_V16QImode) != 0
              || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2732; /* *fuse_veqv_veqv */

        case E_V4SFmode:
          if (pattern432 (x2, 
E_V4SFmode) != 0
              || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2733; /* *fuse_veqv_veqv */

        case E_V2DFmode:
          if (pattern432 (x2, 
E_V2DFmode) != 0
              || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2734; /* *fuse_veqv_veqv */

        case E_V2DImode:
          if (pattern432 (x2, 
E_V2DImode) != 0
              || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2735; /* *fuse_veqv_veqv */

        case E_V1TImode:
          if (pattern432 (x2, 
E_V1TImode) != 0
              || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2736; /* *fuse_veqv_veqv */

        case E_TImode:
          if (pattern432 (x2, 
E_TImode) != 0
              || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2737; /* *fuse_veqv_veqv */

        case E_KFmode:
          if (pattern432 (x2, 
E_KFmode) != 0
              || !(
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2738; /* *fuse_veqv_veqv */

        case E_TFmode:
          if (pattern432 (x2, 
E_TFmode) != 0
              || !(
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2739; /* *fuse_veqv_veqv */

        default:
          return -1;
        }

    case IOR:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case NOT:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x9 = XEXP (x5, 1);
          switch (GET_CODE (x9))
            {
            case NOT:
              switch (pattern405 (x2))
                {
                case 0:
                  if (!
#line 745 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2424; /* *fuse_nand_eqv */

                case 1:
                  if (!(
#line 745 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2425; /* *fuse_nand_eqv */

                case 2:
                  if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2740; /* *fuse_vnand_veqv */

                case 3:
                  if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2741; /* *fuse_vnand_veqv */

                case 4:
                  if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2742; /* *fuse_vnand_veqv */

                case 5:
                  if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2743; /* *fuse_vnand_veqv */

                case 6:
                  if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2744; /* *fuse_vnand_veqv */

                case 7:
                  if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2745; /* *fuse_vnand_veqv */

                case 8:
                  if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2746; /* *fuse_vnand_veqv */

                case 9:
                  if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2747; /* *fuse_vnand_veqv */

                case 10:
                  if (!(
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2748; /* *fuse_vnand_veqv */

                case 11:
                  if (!(
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2749; /* *fuse_vnand_veqv */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern402 (x2))
                {
                case 0:
                  if (!
#line 799 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2430; /* *fuse_orc_eqv */

                case 1:
                  if (!(
#line 799 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2431; /* *fuse_orc_eqv */

                case 2:
                  if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2770; /* *fuse_vorc_veqv */

                case 3:
                  if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2771; /* *fuse_vorc_veqv */

                case 4:
                  if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2772; /* *fuse_vorc_veqv */

                case 5:
                  if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2773; /* *fuse_vorc_veqv */

                case 6:
                  if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2774; /* *fuse_vorc_veqv */

                case 7:
                  if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2775; /* *fuse_vorc_veqv */

                case 8:
                  if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2776; /* *fuse_vorc_veqv */

                case 9:
                  if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2777; /* *fuse_vorc_veqv */

                case 10:
                  if (!(
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2778; /* *fuse_vorc_veqv */

                case 11:
                  if (!(
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2779; /* *fuse_vorc_veqv */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern263 (x2))
            {
            case 0:
              if (!
#line 781 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2428; /* *fuse_or_eqv */

            case 1:
              if (!(
#line 781 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2429; /* *fuse_or_eqv */

            case 2:
              if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2760; /* *fuse_vor_veqv */

            case 3:
              if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2761; /* *fuse_vor_veqv */

            case 4:
              if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2762; /* *fuse_vor_veqv */

            case 5:
              if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2763; /* *fuse_vor_veqv */

            case 6:
              if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2764; /* *fuse_vor_veqv */

            case 7:
              if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2765; /* *fuse_vor_veqv */

            case 8:
              if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2766; /* *fuse_vor_veqv */

            case 9:
              if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2767; /* *fuse_vor_veqv */

            case 10:
              if (!(
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2768; /* *fuse_vor_veqv */

            case 11:
              if (!(
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2769; /* *fuse_vor_veqv */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      switch (pattern263 (x2))
        {
        case 0:
          if (!
#line 817 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2432; /* *fuse_xor_eqv */

        case 1:
          if (!(
#line 817 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2433; /* *fuse_xor_eqv */

        case 2:
          if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2780; /* *fuse_vxor_veqv */

        case 3:
          if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2781; /* *fuse_vxor_veqv */

        case 4:
          if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2782; /* *fuse_vxor_veqv */

        case 5:
          if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2783; /* *fuse_vxor_veqv */

        case 6:
          if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2784; /* *fuse_vxor_veqv */

        case 7:
          if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2785; /* *fuse_vxor_veqv */

        case 8:
          if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2786; /* *fuse_vxor_veqv */

        case 9:
          if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2787; /* *fuse_vxor_veqv */

        case 10:
          if (!(
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2788; /* *fuse_vxor_veqv */

        case 11:
          if (!(
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2789; /* *fuse_vxor_veqv */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !const_0_to_15_operand (operands[2], E_QImode)
          || !
#line 2348 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1951; /* altivec_vspltb_direct */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !
#line 2386 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1953; /* altivec_vsplth_direct */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !const_0_to_3_operand (operands[2], E_QImode)
          || !
#line 2424 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1955; /* altivec_vspltw_direct */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (pattern146 (x3, 
E_DFmode, 
E_TFmode) != 0)
        return -1;
      if ((
#line 14940 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode) && TARGET_HARD_FLOAT) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)))
        return 979; /* packtf_hard */
      if (!(
#line 14964 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode) && TARGET_SOFT_FLOAT) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)))
        return -1;
      return 982; /* packtf_soft */

    case E_IFmode:
      if (pattern146 (x3, 
E_DFmode, 
E_IFmode) != 0
          || !(
#line 14940 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode) && TARGET_HARD_FLOAT) && 
#line 544 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
        return -1;
      return 980; /* packif_hard */

    case E_TDmode:
      if (pattern146 (x3, 
E_DImode, 
E_TDmode) != 0
          || !(
#line 14940 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TDmode) && TARGET_HARD_FLOAT) && 
#line 545 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
        return -1;
      return 981; /* packtd_hard */

    case E_V1TImode:
      if (pattern146 (x3, 
E_DImode, 
E_V1TImode) != 0
          || !
#line 15007 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX))
        return -1;
      return 985; /* packv1ti */

    case E_KFmode:
      if (pattern146 (x3, 
E_DImode, 
E_KFmode) != 0
          || !
#line 15007 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX))
        return -1;
      return 986; /* packkf */

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!nonimmediate_operand (operands[0], E_DFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (pattern412 ())
    {
    case 0:
      if ((
#line 14881 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TFmode)) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)))
        return 973; /* unpacktf_dm */
      if (!(
#line 14904 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TFmode)) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)))
        return -1;
      return 976; /* unpacktf_nodm */

    case 1:
      if ((
#line 14881 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (IFmode)) && 
#line 544 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
        return 974; /* unpackif_dm */
      if (!(
#line 14904 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (IFmode)) && 
#line 544 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
        return -1;
      return 977; /* unpackif_nodm */

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern364 (x3, 
E_SImode) != 0
          || !
#line 2600 "../../gcc/config/rs6000/rs6000.md"
(TARGET_CMPB))
        return -1;
      return 137; /* cmpbsi3 */

    case E_DImode:
      if (pattern364 (x3, 
E_DImode) != 0
          || !(
#line 2600 "../../gcc/config/rs6000/rs6000.md"
(TARGET_CMPB) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
        return -1;
      return 138; /* cmpbdi3 */

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 6851 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 474; /* roundsf2 */

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 6851 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 475; /* rounddf2 */

    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x2) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15477 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1075; /* roundkf2 */

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x2) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15477 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1076; /* roundtf2 */

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern212 (x2))
    {
    case 0:
      if (!
#line 6840 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 472; /* floorsf2 */

    case 1:
      if (!
#line 6840 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 473; /* floordf2 */

    case 2:
      if (!(
#line 15447 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1069; /* floorkf2 */

    case 3:
      if (!(
#line 15447 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1070; /* floortf2 */

    case 4:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && 
#line 2339 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1309; /* vsx_floorv4sf2 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2589 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1994; /* *altivec_vrfim */

    case 5:
      if (!
#line 2339 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1310; /* vsx_floorv2df2 */

    default:
      return -1;
    }
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !gpc_reg_operand (operands[1], E_SImode)
          || !
#line 2523 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTB))
        return -1;
      return 126; /* popcntbsi2 */

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || !gpc_reg_operand (operands[1], E_DImode)
          || !(
#line 2523 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTB) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
        return -1;
      return 127; /* popcntbdi2 */

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern319 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 6804 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POPCNTD))
            return -1;
          return 464; /* *lrintsfsi */

        case 1:
          if (!
#line 6804 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POPCNTD))
            return -1;
          return 465; /* *lrintdfsi */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern319 (x2, 
E_DImode))
        {
        case 0:
          if (!
#line 6812 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POPCNTD))
            return -1;
          return 466; /* lrintsfsi_di */

        case 1:
          if (!
#line 6812 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POPCNTD))
            return -1;
          return 467; /* lrintdfsi_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern161 (x1))
    {
    case 0:
      if (!
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1982; /* *altivec_vpermr_v4si_internal */

    case 1:
      if (!
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1983; /* *altivec_vpermr_v8hi_internal */

    case 2:
      if (!
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1984; /* *altivec_vpermr_v16qi_internal */

    case 3:
      if (!
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1985; /* *altivec_vpermr_v4sf_internal */

    case 4:
      if (!
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1986; /* *altivec_vpermr_v2df_internal */

    case 5:
      if (!
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1987; /* *altivec_vpermr_v2di_internal */

    case 6:
      if (!
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1988; /* *altivec_vpermr_v1ti_internal */

    case 7:
      if (!
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1989; /* *altivec_vpermr_ti_internal */

    case 8:
      if (!(
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 1990; /* *altivec_vpermr_kf_internal */

    case 9:
      if (!(
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 1991; /* *altivec_vpermr_tf_internal */

    default:
      return -1;
    }
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_V1TImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_V2DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 2)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !vsx_register_operand (operands[0], E_V1TImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  if (!vsx_register_operand (operands[1], E_V1TImode)
      || !
#line 3348 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
    return -1;
  return 1366; /* xxswapd_v1ti */
}

 int
recog_113 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      switch (XVECLEN (x4, 0))
        {
        case 2:
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x4, 0, 1);
          operands[2] = x6;
          switch (XINT (x4, 1))
            {
            case 14:
              if (GET_MODE (x4) != E_DImode
                  || !rs6000_tls_symbol_ref (operands[1], E_DImode)
                  || !gpc_reg_operand (operands[2], E_DImode)
                  || !(
#line 10598 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 735; /* *tls_gd_high64 */

            case 23:
              if (GET_MODE (x4) != E_DImode
                  || !gpc_reg_operand (operands[1], E_DImode)
                  || !rs6000_tls_symbol_ref (operands[2], E_DImode)
                  || !(
#line 10711 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 745; /* *tls_got_dtprel_high64 */

            case 27:
              if (GET_MODE (x4) != E_DImode
                  || !gpc_reg_operand (operands[1], E_DImode)
                  || !rs6000_tls_symbol_ref (operands[2], E_DImode)
                  || !(
#line 10791 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 752; /* *tls_got_tprel_high64 */

            case 47:
              if (!gpc_reg_operand (operands[2], E_DImode)
                  || !
#line 11286 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL))
                return -1;
              return 764; /* *largetoc_high */

            default:
              return -1;
            }

        case 1:
          if (XINT (x4, 1) != 15
              || GET_MODE (x4) != E_DImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!gpc_reg_operand (operands[1], E_DImode)
              || !(
#line 10644 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 739; /* *tls_ld_high64 */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 2
          || XINT (x7, 1) != 47)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      operands[1] = x8;
      x9 = XVECEXP (x7, 0, 1);
      operands[2] = x9;
      if (!gpc_reg_operand (operands[2], E_DImode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[3] = x10;
      if (!add_cint_operand (operands[3], E_DImode)
          || !
#line 11306 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL))
        return -1;
      return 765; /* *largetoc_high_plus */

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      operands[1] = x4;
      if (s8bit_cint_operand (operands[1], E_SImode)
          && vsx_register_operand (operands[0], E_V16QImode)
          && GET_MODE (x3) == E_V16QImode
          && 
#line 1146 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1177; /* xxspltib_v16qi */
      if (!s5bit_cint_operand (operands[1], E_QImode)
          || !register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 2461 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1959; /* altivec_vspltisb */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode)
            return -1;
          if (gpc_reg_operand (operands[1], E_DFmode)
              && 
#line 4787 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
            return 1501; /* vsx_splat_v2df_reg */
          if (!memory_operand (operands[1], E_DFmode)
              || !
#line 4797 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
            return -1;
          return 1503; /* vsx_splat_v2df_mem */

        case E_V4SFmode:
          if (!vsx_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !splat_input_operand (operands[1], E_SFmode)
              || !
#line 4832 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1507; /* vsx_splat_v4sf */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode
              || GET_MODE (x4) != E_SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && u5bit_cint_operand (operands[2], E_QImode)
              && 
#line 4856 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)))
            return 1508; /* vsx_xxspltw_v4sf */
          if (!register_operand (operands[0], E_V4SFmode)
              || !register_operand (operands[1], E_V4SFmode)
              || !const_0_to_3_operand (operands[2], E_QImode)
              || !
#line 2448 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
            return -1;
          return 1956; /* *altivec_vspltsf_internal */

        case E_V16QImode:
          if (pattern418 (x3, 
E_V16QImode, 
E_QImode) != 0
              || !const_0_to_15_operand (operands[2], E_QImode)
              || !
#line 2334 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1950; /* *altivec_vspltb_internal */

        default:
          return -1;
        }

    case TRUNCATE:
      if (GET_MODE (x4) != E_QImode
          || !altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!altivec_register_operand (operands[1], E_DImode)
          || !
#line 4880 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 1512; /* vsx_vspltb_di */

    default:
      return -1;
    }
}

 int
recog_118 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 2:
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (GET_MODE (x2) != E_V2DImode)
            return -1;
          if (vsx_register_operand (operands[0], E_V2DImode)
              && memory_operand (operands[1], E_V2DImode)
              && 
#line 1393 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !BYTES_BIG_ENDIAN))
            return 1213; /* vsx_ld_elemrev_v2di */
          if (memory_operand (operands[0], E_V2DImode)
              && vsx_register_operand (operands[1], E_V2DImode))
            {
              if (
#line 1563 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !BYTES_BIG_ENDIAN))
                return 1222; /* vsx_st_elemrev_v2di */
              if (
#line 1625 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
                return 1225; /* *vsx_st_elemrev_v2di_internal */
            }
          if (vsx_register_operand (operands[0], E_V2DImode))
            {
              if (vsx_register_operand (operands[1], E_V2DImode))
                {
                  if (
#line 3280 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DImode)))
                    return 1359; /* *vsx_xxpermdi2_le_v2di */
                  if (
#line 3333 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                    return 1365; /* xxswapd_v2di */
                }
              if (memory_operand (operands[1], E_V2DImode)
                  && 
#line 3391 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DImode) && !TARGET_P9_VECTOR))
                return 1372; /* *vsx_lxvd2x2_le_v2di */
            }
          if (!memory_operand (operands[0], E_V2DImode)
              || !vsx_register_operand (operands[1], E_V2DImode)
              || !
#line 3440 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DImode) && !TARGET_P9_VECTOR))
            return -1;
          return 1378; /* *vsx_stxvd2x2_le_v2di */

        case E_V2DFmode:
          if (GET_MODE (x2) != E_V2DFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V2DFmode)
              && memory_operand (operands[1], E_V2DFmode)
              && 
#line 1413 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
            return 1215; /* vsx_ld_elemrev_v2df */
          if (memory_operand (operands[0], E_V2DFmode)
              && vsx_register_operand (operands[1], E_V2DFmode)
              && 
#line 1554 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
            return 1221; /* vsx_st_elemrev_v2df */
          if (vsx_register_operand (operands[0], E_V2DFmode))
            {
              if (vsx_register_operand (operands[1], E_V2DFmode))
                {
                  if (
#line 3280 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DFmode)))
                    return 1358; /* *vsx_xxpermdi2_le_v2df */
                  if (
#line 3333 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                    return 1364; /* xxswapd_v2df */
                }
              if (memory_operand (operands[1], E_V2DFmode)
                  && 
#line 3391 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DFmode) && !TARGET_P9_VECTOR))
                return 1371; /* *vsx_lxvd2x2_le_v2df */
            }
          if (!memory_operand (operands[0], E_V2DFmode)
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 3440 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DFmode) && !TARGET_P9_VECTOR))
            return -1;
          return 1377; /* *vsx_stxvd2x2_le_v2df */

        default:
          return -1;
        }

    case 1:
      return recog_117 (x1, insn, pnum_clobbers);

    case 4:
      if (pattern223 (x4) != 0)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      switch (XWINT (x5, 0))
        {
        case 3L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 2L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 1L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 0L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (GET_MODE (x2) != E_V4SImode)
                return -1;
              if (vsx_register_operand (operands[0], E_V4SImode)
                  && memory_operand (operands[1], E_V4SImode)
                  && 
#line 1423 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && !BYTES_BIG_ENDIAN))
                return 1216; /* vsx_ld_elemrev_v4si */
              if (!memory_operand (operands[0], E_V4SImode)
                  || !vsx_register_operand (operands[1], E_V4SImode)
                  || !
#line 1583 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && !BYTES_BIG_ENDIAN))
                return -1;
              return 1224; /* vsx_st_elemrev_v4si */

            case E_V4SFmode:
              if (GET_MODE (x2) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[0], E_V4SFmode)
                  && memory_operand (operands[1], E_V4SFmode)
                  && 
#line 1433 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && !BYTES_BIG_ENDIAN))
                return 1217; /* vsx_ld_elemrev_v4sf */
              if (!memory_operand (operands[0], E_V4SFmode)
                  || !vsx_register_operand (operands[1], E_V4SFmode)
                  || !
#line 1573 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && !BYTES_BIG_ENDIAN))
                return -1;
              return 1223; /* vsx_st_elemrev_v4sf */

            default:
              return -1;
            }

        case 2L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 3L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 0L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 1L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (GET_MODE (x2) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[0], E_V4SFmode))
                {
                  if (vsx_register_operand (operands[1], E_V4SFmode)
                      && 
#line 3322 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                    return 1362; /* xxswapd_v4sf */
                  if (memory_operand (operands[1], E_V4SFmode)
                      && 
#line 3401 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V4SFmode) && !TARGET_P9_VECTOR))
                    return 1373; /* *vsx_lxvd2x4_le_v4sf */
                }
              if (!memory_operand (operands[0], E_V4SFmode)
                  || !vsx_register_operand (operands[1], E_V4SFmode)
                  || !
#line 3450 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V4SFmode) && !TARGET_P9_VECTOR))
                return -1;
              return 1379; /* *vsx_stxvd2x4_le_v4sf */

            case E_V4SImode:
              if (GET_MODE (x2) != E_V4SImode)
                return -1;
              if (vsx_register_operand (operands[0], E_V4SImode))
                {
                  if (vsx_register_operand (operands[1], E_V4SImode)
                      && 
#line 3322 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                    return 1363; /* xxswapd_v4si */
                  if (memory_operand (operands[1], E_V4SImode)
                      && 
#line 3401 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V4SImode) && !TARGET_P9_VECTOR))
                    return 1374; /* *vsx_lxvd2x4_le_v4si */
                }
              if (!memory_operand (operands[0], E_V4SImode)
                  || !vsx_register_operand (operands[1], E_V4SImode)
                  || !
#line 3450 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V4SImode) && !TARGET_P9_VECTOR))
                return -1;
              return 1380; /* *vsx_stxvd2x4_le_v4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 8:
      if (pattern222 (x4) != 0
          || GET_MODE (x2) != E_V8HImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      switch (XWINT (x5, 0))
        {
        case 7L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 6L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 5L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 4L)
            return -1;
          x9 = XVECEXP (x4, 0, 4);
          if (XWINT (x9, 0) != 3L)
            return -1;
          x10 = XVECEXP (x4, 0, 5);
          if (XWINT (x10, 0) != 2L)
            return -1;
          x11 = XVECEXP (x4, 0, 6);
          if (XWINT (x11, 0) != 1L)
            return -1;
          x12 = XVECEXP (x4, 0, 7);
          if (XWINT (x12, 0) != 0L)
            return -1;
          if (vsx_register_operand (operands[0], E_V8HImode)
              && memory_operand (operands[1], E_V8HImode)
              && 
#line 1479 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
            return 1218; /* *vsx_ld_elemrev_v8hi_internal */
          if (!memory_operand (operands[0], E_V8HImode)
              || !vsx_register_operand (operands[1], E_V8HImode)
              || !
#line 1637 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
            return -1;
          return 1226; /* *vsx_st_elemrev_v8hi_internal */

        case 4L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 5L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 6L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 7L)
            return -1;
          x9 = XVECEXP (x4, 0, 4);
          if (XWINT (x9, 0) != 0L)
            return -1;
          x10 = XVECEXP (x4, 0, 5);
          if (XWINT (x10, 0) != 1L)
            return -1;
          x11 = XVECEXP (x4, 0, 6);
          if (XWINT (x11, 0) != 2L)
            return -1;
          x12 = XVECEXP (x4, 0, 7);
          if (XWINT (x12, 0) != 3L)
            return -1;
          if (vsx_register_operand (operands[0], E_V8HImode))
            {
              if (vsx_register_operand (operands[1], E_V8HImode)
                  && 
#line 3310 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                return 1361; /* xxswapd_v8hi */
              if (memory_operand (operands[1], E_V8HImode)
                  && 
#line 3413 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V8HImode) && !TARGET_P9_VECTOR))
                return 1375; /* *vsx_lxvd2x8_le_V8HI */
            }
          if (!memory_operand (operands[0], E_V8HImode)
              || !vsx_register_operand (operands[1], E_V8HImode)
              || !
#line 3489 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V8HImode) && !TARGET_P9_VECTOR))
            return -1;
          return 1383; /* *vsx_stxvd2x8_le_V8HI */

        default:
          return -1;
        }

    case 16:
      if (pattern221 (x4) != 0
          || GET_MODE (x2) != E_V16QImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      switch (XWINT (x5, 0))
        {
        case 15L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 14L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 13L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 12L)
            return -1;
          x9 = XVECEXP (x4, 0, 4);
          if (XWINT (x9, 0) != 11L)
            return -1;
          x10 = XVECEXP (x4, 0, 5);
          if (XWINT (x10, 0) != 10L)
            return -1;
          x11 = XVECEXP (x4, 0, 6);
          if (XWINT (x11, 0) != 9L)
            return -1;
          x12 = XVECEXP (x4, 0, 7);
          if (XWINT (x12, 0) != 8L)
            return -1;
          x13 = XVECEXP (x4, 0, 8);
          if (XWINT (x13, 0) != 7L)
            return -1;
          x14 = XVECEXP (x4, 0, 9);
          if (XWINT (x14, 0) != 6L)
            return -1;
          x15 = XVECEXP (x4, 0, 10);
          if (XWINT (x15, 0) != 5L)
            return -1;
          x16 = XVECEXP (x4, 0, 11);
          if (XWINT (x16, 0) != 4L)
            return -1;
          x17 = XVECEXP (x4, 0, 12);
          if (XWINT (x17, 0) != 3L)
            return -1;
          x18 = XVECEXP (x4, 0, 13);
          if (XWINT (x18, 0) != 2L)
            return -1;
          x19 = XVECEXP (x4, 0, 14);
          if (XWINT (x19, 0) != 1L)
            return -1;
          x20 = XVECEXP (x4, 0, 15);
          if (XWINT (x20, 0) != 0L)
            return -1;
          if (vsx_register_operand (operands[0], E_V16QImode)
              && memory_operand (operands[1], E_V16QImode)
              && 
#line 1533 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
            return 1219; /* vsx_ld_elemrev_v16qi_internal */
          if (!memory_operand (operands[0], E_V16QImode)
              || !vsx_register_operand (operands[1], E_V16QImode)
              || !
#line 1690 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
            return -1;
          return 1227; /* *vsx_st_elemrev_v16qi_internal */

        case 8L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 9L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 10L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 11L)
            return -1;
          x9 = XVECEXP (x4, 0, 4);
          if (XWINT (x9, 0) != 12L)
            return -1;
          x10 = XVECEXP (x4, 0, 5);
          if (XWINT (x10, 0) != 13L)
            return -1;
          x11 = XVECEXP (x4, 0, 6);
          if (XWINT (x11, 0) != 14L)
            return -1;
          x12 = XVECEXP (x4, 0, 7);
          if (XWINT (x12, 0) != 15L)
            return -1;
          x13 = XVECEXP (x4, 0, 8);
          if (XWINT (x13, 0) != 0L)
            return -1;
          x14 = XVECEXP (x4, 0, 9);
          if (XWINT (x14, 0) != 1L)
            return -1;
          x15 = XVECEXP (x4, 0, 10);
          if (XWINT (x15, 0) != 2L)
            return -1;
          x16 = XVECEXP (x4, 0, 11);
          if (XWINT (x16, 0) != 3L)
            return -1;
          x17 = XVECEXP (x4, 0, 12);
          if (XWINT (x17, 0) != 4L)
            return -1;
          x18 = XVECEXP (x4, 0, 13);
          if (XWINT (x18, 0) != 5L)
            return -1;
          x19 = XVECEXP (x4, 0, 14);
          if (XWINT (x19, 0) != 6L)
            return -1;
          x20 = XVECEXP (x4, 0, 15);
          if (XWINT (x20, 0) != 7L)
            return -1;
          if (vsx_register_operand (operands[0], E_V16QImode))
            {
              if (vsx_register_operand (operands[1], E_V16QImode)
                  && 
#line 3296 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                return 1360; /* xxswapd_v16qi */
              if (memory_operand (operands[1], E_V16QImode)
                  && 
#line 3429 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V16QImode) && !TARGET_P9_VECTOR))
                return 1376; /* *vsx_lxvd2x16_le_V16QI */
            }
          if (!memory_operand (operands[0], E_V16QImode)
              || !vsx_register_operand (operands[1], E_V16QImode)
              || !
#line 3505 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V16QImode) && !TARGET_P9_VECTOR))
            return -1;
          return 1384; /* *vsx_stxvd2x16_le_V16QI */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_127 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      switch (XINT (x2, 1))
        {
        case 11:
          if (GET_MODE (x2) != E_DFmode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!gpc_reg_operand (operands[0], E_DFmode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_CODE (operands[1]))
            {
            case REG:
            case SUBREG:
              if (!gpc_reg_operand (operands[1], E_DFmode)
                  || !
#line 6526 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
                return -1;
              return 450; /* rs6000_mffscrn */

            case CONST_INT:
              if (!const_0_to_3_operand (operands[1], E_SImode)
                  || !
#line 6534 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
                return -1;
              return 451; /* rs6000_mffscrni */

            default:
              return -1;
            }

        case 6:
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          switch (pattern206 (x2))
            {
            case 0:
              if (pnum_clobbers != NULL
                  && 
#line 14589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64))
                {
                  *pnum_clobbers = 2;
                  return 955; /* rs6000_get_timebase_ppc32 */
                }
              if (!
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 957; /* rs6000_mftb_di */

            case 1:
              return 956; /* rs6000_mftb_si */

            default:
              return -1;
            }

        case 10:
          if (GET_MODE (x2) != E_DFmode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || !
#line 14645 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 958; /* rs6000_mffsl_hw */

        case 9:
          if (GET_MODE (x2) != E_DFmode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || !
#line 14681 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 959; /* rs6000_mffs */

        case 7:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !
#line 15638 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
                return -1;
              return 1099; /* darnsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !(
#line 15638 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 1100; /* darndi */

            default:
              return -1;
            }

        case 95:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!simple_offsettable_mem_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!int_reg_operand (operands[1], E_DImode)
              || !
#line 15845 "../../gcc/config/rs6000/rs6000.md"
(rs6000_rop_protect))
            return -1;
          return 1106; /* hashst */

        case 1:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!int_reg_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !memory_operand (operands[1], E_QImode)
                  || !
#line 273 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                return -1;
              return 1118; /* load_lockedqi */

            case E_HImode:
              if (!int_reg_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !memory_operand (operands[1], E_HImode)
                  || !
#line 274 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                return -1;
              return 1119; /* load_lockedhi */

            case E_SImode:
              if (!int_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (!memory_operand (operands[1], E_SImode))
                    return -1;
                  return 1120; /* load_lockedsi */

                case E_QImode:
                  if (!memory_operand (operands[1], E_QImode)
                      || !
#line 290 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                    return -1;
                  return 1122; /* load_lockedqi_si */

                case E_HImode:
                  if (!memory_operand (operands[1], E_HImode)
                      || !
#line 290 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                    return -1;
                  return 1123; /* load_lockedhi_si */

                default:
                  return -1;
                }

            case E_DImode:
              if (!int_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !memory_operand (operands[1], E_DImode)
                  || !
#line 276 "../../gcc/config/rs6000/sync.md"
(TARGET_POWERPC64))
                return -1;
              return 1121; /* load_lockeddi */

            case E_PTImode:
              if (!quad_int_reg_operand (operands[0], E_PTImode)
                  || GET_MODE (x2) != E_PTImode
                  || !indexed_or_indirect_operand (operands[1], E_TImode)
                  || !
#line 334 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI
   && !reg_mentioned_p (operands[0], operands[1])
   && quad_int_reg_operand (operands[0], PTImode)))
                return -1;
              return 1124; /* load_lockedpti */

            default:
              return -1;
            }

        case 22:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 109
              || GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_V4SImode)
              || !
#line 2938 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2046; /* altivec_mtvscr */

        case 23:
          if (GET_MODE (x2) != E_V8HImode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 109
              || GET_MODE (x4) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_V8HImode)
              || !
#line 2945 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2047; /* altivec_mfvscr */

        case 27:
          if (GET_MODE (x2) != E_XOmode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!fpr_reg_operand (operands[0], E_XOmode)
              || !
#line 521 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2215; /* mma_xxsetaccz */

        case 38:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!u10bit_cint_operand (operands[1], E_VOIDmode))
            return -1;
          switch (pattern9 (x2))
            {
            case 0:
              if (!
#line 272 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
                return -1;
              return 2356; /* htm_mfspr_si */

            case 1:
              if (!(
#line 272 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2357; /* htm_mfspr_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (XINT (x2, 1))
        {
        case 19:
          if (GET_MODE (x2) != E_DImode
              || !gpc_reg_operand (operands[0], E_DImode)
              || !gpc_reg_operand (operands[1], E_DImode)
              || !symbol_ref_operand (operands[2], E_DImode)
              || !(
#line 11390 "../../gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 771; /* *pltseq_plt16_lo_di */

        case 20:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!gpc_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !symbol_ref_operand (operands[2], E_SImode)
                  || !(
#line 11413 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_PLTSEQ && TARGET_ELF
   && rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 773; /* *pltseq_plt_pcrelsi */

            case E_DImode:
              if (!gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !symbol_ref_operand (operands[2], E_DImode)
                  || !(
#line 11413 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_PLTSEQ && TARGET_ELF
   && rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 774; /* *pltseq_plt_pcreldi */

            default:
              return -1;
            }

        case 3:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode)
              || !register_operand (operands[3], E_DImode))
            return -1;
          return 803; /* probe_stack_rangedi */

        default:
          return -1;
        }

    case 4:
      if (pattern29 (x1) != 0
          || !
#line 455 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && fpr_reg_operand (operands[0], XOmode)))
        return -1;
      return 2211; /* *mma_assemble_acc */

    default:
      return -1;
    }
}

 int
recog_131 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  res = recog_24 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  x5 = XEXP (x3, 1);
  if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
    {
      res = recog_25 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[1] = x4;
  operands[2] = x5;
  switch (GET_CODE (x3))
    {
    case EQ:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!gpc_reg_operand (operands[1], E_SImode))
                return -1;
              if (reg_or_short_operand (operands[2], E_SImode)
                  && 
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                {
                  *pnum_clobbers = 3;
                  return 818; /* eqsisi2_isel */
                }
              if (!scc_eq_operand (operands[2], E_SImode)
                  || !
#line 12928 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)))
                return -1;
              *pnum_clobbers = 2;
              return 858; /* *eqsi3 */

            case E_DImode:
              if (!gpc_reg_operand (operands[1], E_DImode)
                  || !reg_or_short_operand (operands[2], E_DImode)
                  || !(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 838; /* eqsidi2_isel */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern314 (x3))
            {
            case 0:
              if (reg_or_short_operand (operands[2], E_SImode)
                  && (
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                {
                  *pnum_clobbers = 3;
                  return 828; /* eqdisi2_isel */
                }
              if (!scc_eq_operand (operands[2], E_SImode)
                  || !(
#line 13220 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 2;
              return 867; /* *eqsi3_extdi */

            case 1:
              if (reg_or_short_operand (operands[2], E_DImode)
                  && (
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                {
                  *pnum_clobbers = 3;
                  return 848; /* eqdidi2_isel */
                }
              if (!scc_eq_operand (operands[2], E_DImode)
                  || !(
#line 12928 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 2;
              return 859; /* *eqdi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LT:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode))
            return -1;
          switch (pattern302 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              *pnum_clobbers = 3;
              return 820; /* ltsisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 840; /* ltsidi2_isel */

            default:
              return -1;
            }

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode))
            return -1;
          switch (pattern302 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 830; /* ltdisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 850; /* ltdidi2_isel */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LTU:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode))
            return -1;
          switch (pattern125 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              *pnum_clobbers = 3;
              return 821; /* ltusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 841; /* ltusidi2_isel */

            default:
              return -1;
            }

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode))
            return -1;
          switch (pattern125 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 831; /* ltudisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 851; /* ltudidi2_isel */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GT:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode))
            return -1;
          switch (pattern302 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              *pnum_clobbers = 3;
              return 822; /* gtsisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 842; /* gtsidi2_isel */

            default:
              return -1;
            }

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode))
            return -1;
          switch (pattern302 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 832; /* gtdisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 852; /* gtdidi2_isel */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GTU:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode))
            return -1;
          switch (pattern125 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              *pnum_clobbers = 3;
              return 823; /* gtusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 843; /* gtusidi2_isel */

            default:
              return -1;
            }

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode))
            return -1;
          switch (pattern125 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 833; /* gtudisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 853; /* gtudidi2_isel */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_159 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pattern188 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[3], E_DImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_SImode:
          x5 = XEXP (x4, 0);
          switch (GET_MODE (x5))
            {
            case E_SImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern553 (x7, 
E_SImode) != 0
                  || !(
#line 10308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !avoiding_indexed_address_p (DImode)) && (((((
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 697; /* *movsi_update2 */

            case E_DImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern553 (x7, 
E_DImode) != 0
                  || !(
#line 10308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !avoiding_indexed_address_p (DImode)) && (((((
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 698; /* *movsi_update2 */

            default:
              return -1;
            }

        case E_HImode:
          x5 = XEXP (x4, 0);
          switch (GET_MODE (x5))
            {
            case E_SImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern528 (x7, 
E_SImode) != 0
                  || !(
#line 10389 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && (((((
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 708; /* *movhi_update3 */

            case E_DImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern528 (x7, 
E_DImode) != 0
                  || !(
#line 10389 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && (((((
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 710; /* *movhi_update3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_SImode:
      if (!gpc_reg_operand (operands[3], E_SImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_MODE (x5))
        {
        case E_SImode:
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          if (pattern528 (x7, 
E_SImode) != 0
              || !(
#line 10389 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 707; /* *movhi_update3 */

        case E_DImode:
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          if (pattern528 (x7, 
E_DImode) != 0
              || !(
#line 10389 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 709; /* *movhi_update3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XEXP (x2, 0);
      operands[3] = x8;
      if (!scratch_operand (operands[3], E_CCmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern471 (x4, 
E_SImode) != 0
              || !
#line 3642 "../../gcc/config/rs6000/rs6000.md"
(!rs6000_is_valid_and_mask (operands[2], SImode)))
            return -1;
          return 188; /* andsi3_imm */

        case E_DImode:
          if (pattern471 (x4, 
E_DImode) != 0
              || !(
#line 3642 "../../gcc/config/rs6000/rs6000.md"
(!rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 189; /* anddi3_imm */

        default:
          return -1;
        }

    case AND:
      switch (pattern244 (x1))
        {
        case 0:
          if (!
#line 367 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2382; /* *fuse_and_and */

        case 1:
          if (!(
#line 367 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2383; /* *fuse_and_and */

        case 2:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2550; /* *fuse_vand_vand */

        case 3:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2551; /* *fuse_vand_vand */

        case 4:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2552; /* *fuse_vand_vand */

        case 5:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2553; /* *fuse_vand_vand */

        case 6:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2554; /* *fuse_vand_vand */

        case 7:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2555; /* *fuse_vand_vand */

        case 8:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2556; /* *fuse_vand_vand */

        case 9:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2557; /* *fuse_vand_vand */

        case 10:
          if (!(
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2558; /* *fuse_vand_vand */

        case 11:
          if (!(
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2559; /* *fuse_vand_vand */

        case 12:
          if (!
#line 547 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2402; /* *fuse_and_andc */

        case 13:
          if (!(
#line 547 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2403; /* *fuse_and_andc */

        case 14:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2630; /* *fuse_vand_vandc */

        case 15:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2631; /* *fuse_vand_vandc */

        case 16:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2632; /* *fuse_vand_vandc */

        case 17:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2633; /* *fuse_vand_vandc */

        case 18:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2634; /* *fuse_vand_vandc */

        case 19:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2635; /* *fuse_vand_vandc */

        case 20:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2636; /* *fuse_vand_vandc */

        case 21:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2637; /* *fuse_vand_vandc */

        case 22:
          if (!(
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2638; /* *fuse_vand_vandc */

        case 23:
          if (!(
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2639; /* *fuse_vand_vandc */

        case 24:
          if (!
#line 385 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2384; /* *fuse_andc_and */

        case 25:
          if (!(
#line 385 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2385; /* *fuse_andc_and */

        case 26:
          if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2560; /* *fuse_vandc_vand */

        case 27:
          if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2561; /* *fuse_vandc_vand */

        case 28:
          if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2562; /* *fuse_vandc_vand */

        case 29:
          if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2563; /* *fuse_vandc_vand */

        case 30:
          if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2564; /* *fuse_vandc_vand */

        case 31:
          if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2565; /* *fuse_vandc_vand */

        case 32:
          if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2566; /* *fuse_vandc_vand */

        case 33:
          if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2567; /* *fuse_vandc_vand */

        case 34:
          if (!(
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2568; /* *fuse_vandc_vand */

        case 35:
          if (!(
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2569; /* *fuse_vandc_vand */

        case 36:
          if (!
#line 565 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2404; /* *fuse_andc_andc */

        case 37:
          if (!(
#line 565 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2405; /* *fuse_andc_andc */

        case 38:
          if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2640; /* *fuse_vandc_vandc */

        case 39:
          if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2641; /* *fuse_vandc_vandc */

        case 40:
          if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2642; /* *fuse_vandc_vandc */

        case 41:
          if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2643; /* *fuse_vandc_vandc */

        case 42:
          if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2644; /* *fuse_vandc_vandc */

        case 43:
          if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2645; /* *fuse_vandc_vandc */

        case 44:
          if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2646; /* *fuse_vandc_vandc */

        case 45:
          if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2647; /* *fuse_vandc_vandc */

        case 46:
          if (!(
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2648; /* *fuse_vandc_vandc */

        case 47:
          if (!(
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2649; /* *fuse_vandc_vandc */

        case 48:
          if (!
#line 439 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2390; /* *fuse_nor_and */

        case 49:
          if (!(
#line 439 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2391; /* *fuse_nor_and */

        case 50:
          if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2590; /* *fuse_vnor_vand */

        case 51:
          if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2591; /* *fuse_vnor_vand */

        case 52:
          if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2592; /* *fuse_vnor_vand */

        case 53:
          if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2593; /* *fuse_vnor_vand */

        case 54:
          if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2594; /* *fuse_vnor_vand */

        case 55:
          if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2595; /* *fuse_vnor_vand */

        case 56:
          if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2596; /* *fuse_vnor_vand */

        case 57:
          if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2597; /* *fuse_vnor_vand */

        case 58:
          if (!(
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2598; /* *fuse_vnor_vand */

        case 59:
          if (!(
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2599; /* *fuse_vnor_vand */

        case 60:
          if (!
#line 619 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2410; /* *fuse_nor_andc */

        case 61:
          if (!(
#line 619 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2411; /* *fuse_nor_andc */

        case 62:
          if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2670; /* *fuse_vnor_vandc */

        case 63:
          if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2671; /* *fuse_vnor_vandc */

        case 64:
          if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2672; /* *fuse_vnor_vandc */

        case 65:
          if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2673; /* *fuse_vnor_vandc */

        case 66:
          if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2674; /* *fuse_vnor_vandc */

        case 67:
          if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2675; /* *fuse_vnor_vandc */

        case 68:
          if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2676; /* *fuse_vnor_vandc */

        case 69:
          if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2677; /* *fuse_vnor_vandc */

        case 70:
          if (!(
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2678; /* *fuse_vnor_vandc */

        case 71:
          if (!(
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2679; /* *fuse_vnor_vandc */

        default:
          return -1;
        }

    case NOT:
      return recog_157 (x1, insn, pnum_clobbers);

    case IOR:
      switch (pattern245 (x1))
        {
        case 0:
          if (!
#line 421 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2388; /* *fuse_nand_and */

        case 1:
          if (!(
#line 421 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2389; /* *fuse_nand_and */

        case 2:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2580; /* *fuse_vnand_vand */

        case 3:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2581; /* *fuse_vnand_vand */

        case 4:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2582; /* *fuse_vnand_vand */

        case 5:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2583; /* *fuse_vnand_vand */

        case 6:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2584; /* *fuse_vnand_vand */

        case 7:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2585; /* *fuse_vnand_vand */

        case 8:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2586; /* *fuse_vnand_vand */

        case 9:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2587; /* *fuse_vnand_vand */

        case 10:
          if (!(
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2588; /* *fuse_vnand_vand */

        case 11:
          if (!(
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2589; /* *fuse_vnand_vand */

        case 12:
          if (!
#line 601 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2408; /* *fuse_nand_andc */

        case 13:
          if (!(
#line 601 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2409; /* *fuse_nand_andc */

        case 14:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2660; /* *fuse_vnand_vandc */

        case 15:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2661; /* *fuse_vnand_vandc */

        case 16:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2662; /* *fuse_vnand_vandc */

        case 17:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2663; /* *fuse_vnand_vandc */

        case 18:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2664; /* *fuse_vnand_vandc */

        case 19:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2665; /* *fuse_vnand_vandc */

        case 20:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2666; /* *fuse_vnand_vandc */

        case 21:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2667; /* *fuse_vnand_vandc */

        case 22:
          if (!(
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2668; /* *fuse_vnand_vandc */

        case 23:
          if (!(
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2669; /* *fuse_vnand_vandc */

        case 24:
          if (!
#line 475 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2394; /* *fuse_orc_and */

        case 25:
          if (!(
#line 475 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2395; /* *fuse_orc_and */

        case 26:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2610; /* *fuse_vorc_vand */

        case 27:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2611; /* *fuse_vorc_vand */

        case 28:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2612; /* *fuse_vorc_vand */

        case 29:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2613; /* *fuse_vorc_vand */

        case 30:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2614; /* *fuse_vorc_vand */

        case 31:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2615; /* *fuse_vorc_vand */

        case 32:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2616; /* *fuse_vorc_vand */

        case 33:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2617; /* *fuse_vorc_vand */

        case 34:
          if (!(
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2618; /* *fuse_vorc_vand */

        case 35:
          if (!(
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2619; /* *fuse_vorc_vand */

        case 36:
          if (!
#line 655 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2414; /* *fuse_orc_andc */

        case 37:
          if (!(
#line 655 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2415; /* *fuse_orc_andc */

        case 38:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2690; /* *fuse_vorc_vandc */

        case 39:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2691; /* *fuse_vorc_vandc */

        case 40:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2692; /* *fuse_vorc_vandc */

        case 41:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2693; /* *fuse_vorc_vandc */

        case 42:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2694; /* *fuse_vorc_vandc */

        case 43:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2695; /* *fuse_vorc_vandc */

        case 44:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2696; /* *fuse_vorc_vandc */

        case 45:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2697; /* *fuse_vorc_vandc */

        case 46:
          if (!(
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2698; /* *fuse_vorc_vandc */

        case 47:
          if (!(
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2699; /* *fuse_vorc_vandc */

        case 48:
          if (!
#line 457 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2392; /* *fuse_or_and */

        case 49:
          if (!(
#line 457 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2393; /* *fuse_or_and */

        case 50:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2600; /* *fuse_vor_vand */

        case 51:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2601; /* *fuse_vor_vand */

        case 52:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2602; /* *fuse_vor_vand */

        case 53:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2603; /* *fuse_vor_vand */

        case 54:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2604; /* *fuse_vor_vand */

        case 55:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2605; /* *fuse_vor_vand */

        case 56:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2606; /* *fuse_vor_vand */

        case 57:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2607; /* *fuse_vor_vand */

        case 58:
          if (!(
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2608; /* *fuse_vor_vand */

        case 59:
          if (!(
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2609; /* *fuse_vor_vand */

        case 60:
          if (!
#line 637 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2412; /* *fuse_or_andc */

        case 61:
          if (!(
#line 637 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2413; /* *fuse_or_andc */

        case 62:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2680; /* *fuse_vor_vandc */

        case 63:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2681; /* *fuse_vor_vandc */

        case 64:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2682; /* *fuse_vor_vandc */

        case 65:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2683; /* *fuse_vor_vandc */

        case 66:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2684; /* *fuse_vor_vandc */

        case 67:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2685; /* *fuse_vor_vandc */

        case 68:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2686; /* *fuse_vor_vandc */

        case 69:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2687; /* *fuse_vor_vandc */

        case 70:
          if (!(
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2688; /* *fuse_vor_vandc */

        case 71:
          if (!(
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2689; /* *fuse_vor_vandc */

        default:
          return -1;
        }

    case XOR:
      switch (pattern246 (x1))
        {
        case 0:
          if (!
#line 493 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2396; /* *fuse_xor_and */

        case 1:
          if (!(
#line 493 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2397; /* *fuse_xor_and */

        case 2:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2620; /* *fuse_vxor_vand */

        case 3:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2621; /* *fuse_vxor_vand */

        case 4:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2622; /* *fuse_vxor_vand */

        case 5:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2623; /* *fuse_vxor_vand */

        case 6:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2624; /* *fuse_vxor_vand */

        case 7:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2625; /* *fuse_vxor_vand */

        case 8:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2626; /* *fuse_vxor_vand */

        case 9:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2627; /* *fuse_vxor_vand */

        case 10:
          if (!(
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2628; /* *fuse_vxor_vand */

        case 11:
          if (!(
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2629; /* *fuse_vxor_vand */

        case 12:
          if (!
#line 673 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2416; /* *fuse_xor_andc */

        case 13:
          if (!(
#line 673 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2417; /* *fuse_xor_andc */

        case 14:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2700; /* *fuse_vxor_vandc */

        case 15:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2701; /* *fuse_vxor_vandc */

        case 16:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2702; /* *fuse_vxor_vandc */

        case 17:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2703; /* *fuse_vxor_vandc */

        case 18:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2704; /* *fuse_vxor_vandc */

        case 19:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2705; /* *fuse_vxor_vandc */

        case 20:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2706; /* *fuse_vxor_vandc */

        case 21:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2707; /* *fuse_vxor_vandc */

        case 22:
          if (!(
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2708; /* *fuse_vxor_vandc */

        case 23:
          if (!(
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2709; /* *fuse_vxor_vandc */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern248 (x1))
        {
        case 0:
          if (!
#line 511 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2398; /* *fuse_add_and */

        case 1:
          if (!(
#line 511 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2399; /* *fuse_add_and */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern248 (x1))
        {
        case 0:
          if (!
#line 529 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2400; /* *fuse_subf_and */

        case 1:
          if (!(
#line 529 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2401; /* *fuse_subf_and */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case CLOBBER:
          switch (pattern169 (x1))
            {
            case 0:
              if (logical_const_operand (operands[2], E_SImode)
                  && (
#line 3705 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], SImode)) && 
#line 3710 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_70 (insn, operands);
              if (!const_int_operand (operands[2], E_SImode))
                return NULL;
              if ((
#line 3785 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_and_mask (operands[2], SImode)) && 
#line 3794 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_74 (insn, operands);
              if (!(
#line 3859 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))) && 
#line 3864 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_80 (insn, operands);

            case 1:
              if (logical_const_operand (operands[2], E_DImode)
                  && ((
#line 3705 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3710 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_71 (insn, operands);
              if (!const_int_operand (operands[2], E_DImode))
                return NULL;
              if (((
#line 3785 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3794 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_75 (insn, operands);
              if (!((
#line 3859 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3864 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_81 (insn, operands);

            default:
              return NULL;
            }

        case SET:
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != AND)
            return NULL;
          switch (pattern173 (x1))
            {
            case 0:
              if (logical_const_operand (operands[2], E_SImode)
                  && (
#line 3730 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], SImode)) && 
#line 3735 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_72 (insn, operands);
              if (!const_int_operand (operands[2], E_SImode))
                return NULL;
              if ((
#line 3814 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_and_mask (operands[2], SImode)) && 
#line 3823 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_76 (insn, operands);
              if (!(
#line 3882 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))) && 
#line 3887 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_82 (insn, operands);

            case 1:
              if (logical_const_operand (operands[2], E_DImode)
                  && ((
#line 3730 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3735 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_73 (insn, operands);
              if (!const_int_operand (operands[2], E_DImode))
                return NULL;
              if (((
#line 3814 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3823 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                return gen_split_77 (insn, operands);
              if (!((
#line 3882 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3887 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_83 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ASHIFT:
    case ROTATE:
    case LSHIFTRT:
      operands[4] = x5;
      x6 = XEXP (x2, 0);
      operands[5] = x6;
      x10 = XEXP (x5, 0);
      operands[1] = x10;
      switch (pattern490 (x1))
        {
        case 0:
          if (!(
#line 4198 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], SImode)) && 
#line 4206 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[5], CCmode))))
            return NULL;
          return gen_split_101 (insn, operands);

        case 1:
          if (!((
#line 4198 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4206 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[5], CCmode))))
            return NULL;
          return gen_split_102 (insn, operands);

        case 2:
          if (!(
#line 4230 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], SImode)) && 
#line 4238 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[5], CCmode))))
            return NULL;
          return gen_split_103 (insn, operands);

        case 3:
          if (!((
#line 4230 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4238 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[5], CCmode))))
            return NULL;
          return gen_split_104 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case COMPARE:
          return split_2 (x1, insn);

        case BSWAP:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          switch (GET_CODE (operands[1]))
            {
            case REG:
            case SUBREG:
              switch (GET_CODE (operands[0]))
                {
                case REG:
                case SUBREG:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (!gpc_reg_operand (operands[0], E_HImode)
                          || GET_MODE (x3) != E_HImode
                          || !gpc_reg_operand (operands[1], E_HImode)
                          || !scratch_operand (operands[2], E_SImode)
                          || !
#line 2677 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWER10 && int_reg_operand (operands[0], HImode)))
                        return NULL;
                      return gen_split_50 (insn, operands);

                    case E_DImode:
                      if (!gpc_reg_operand (operands[0], E_DImode)
                          || GET_MODE (x3) != E_DImode
                          || !gpc_reg_operand (operands[1], E_DImode)
                          || !
#line 3086 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && reload_completed))
                        return NULL;
                      return gen_split_57 (insn, operands);

                    default:
                      return NULL;
                    }

                case MEM:
                  if (!indexed_or_indirect_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || !gpc_reg_operand (operands[1], E_DImode)
                      || !gpc_reg_operand (operands[2], E_SImode)
                      || !
#line 3038 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && reload_completed))
                    return NULL;
                  return gen_split_56 (insn, operands);

                default:
                  return NULL;
                }

            case MEM:
              if (!indexed_or_indirect_operand (operands[1], E_DImode)
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 2986 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && reload_completed))
                return NULL;
              return gen_split_55 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[1] = x6;
              switch (pattern337 (x1))
                {
                case 0:
                  if (!(
#line 4472 "../../gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, SImode)) && 
#line 4475 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_119 (insn, operands);

                case 1:
                  if (!((
#line 4472 "../../gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4475 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_120 (insn, operands);

                default:
                  return NULL;
                }

            case ASHIFT:
              if (pattern249 (x3) != 0)
                return NULL;
              switch (pattern503 (x1))
                {
                case 0:
                  if (!(
#line 4528 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 8) && 
#line 4530 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_124 (insn, operands);

                case 1:
                  if (!(
#line 4528 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 16) && 
#line 4530 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_125 (insn, operands);

                case 2:
                  if (!(
#line 4528 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 32) && 
#line 4530 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_126 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case IF_THEN_ELSE:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          x8 = XEXP (x3, 1);
          operands[4] = x8;
          x9 = XEXP (x3, 2);
          operands[5] = x9;
          x7 = XEXP (x4, 0);
          operands[6] = x7;
          if (!scratch_operand (operands[6], E_V2DImode))
            return NULL;
          switch (GET_CODE (operands[1]))
            {
            case EQ:
            case GE:
            case GT:
              if (!fpmask_comparison_operator (operands[1], E_CCFPmode))
                return NULL;
              switch (pattern509 (x3))
                {
                case 0:
                  if (!(
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5667 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_161 (insn, operands);

                case 1:
                  if (!(
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5667 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_163 (insn, operands);

                case 2:
                  if (!(
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5667 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_162 (insn, operands);

                case 3:
                  if (!(
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5667 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_164 (insn, operands);

                case 4:
                  if (!((
#line 5770 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 5772 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_169 (insn, operands);

                case 5:
                  if (!((
#line 5770 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 5772 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_170 (insn, operands);

                default:
                  return NULL;
                }

            case NE:
            case UNLE:
            case UNLT:
              if (!invert_fpmask_comparison_operator (operands[1], E_CCFPmode))
                return NULL;
              switch (pattern509 (x3))
                {
                case 0:
                  if (!(
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5699 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_165 (insn, operands);

                case 1:
                  if (!(
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5699 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_167 (insn, operands);

                case 2:
                  if (!(
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5699 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_166 (insn, operands);

                case 3:
                  if (!(
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5699 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_168 (insn, operands);

                case 4:
                  if (!((
#line 5802 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 5804 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_171 (insn, operands);

                case 5:
                  if (!((
#line 5802 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 5804 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_172 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case FLOAT:
          return split_5 (x1, insn);

        case UNSIGNED_FLOAT:
          switch (pattern76 (x1))
            {
            case 0:
              if (!(
#line 5976 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS) && 
#line 5978 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_181 (insn, operands);

            case 1:
              if (!(
#line 7129 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDUS) && 
#line 7131 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_229 (insn, operands);

            case 2:
              if (!(
#line 5976 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID) && 
#line 5978 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_182 (insn, operands);

            case 3:
              if (!(
#line 7004 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && (TARGET_FCFIDU || VECTOR_UNIT_VSX_P (DFmode))) && 
#line 7006 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_226 (insn, operands);

            case 4:
              if (!((
#line 15394 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15396 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_510 (insn, operands);

            case 5:
              if (!((
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15416 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_512 (insn, operands);

            case 6:
              if (!((
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15416 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_513 (insn, operands);

            case 7:
              if (!((
#line 15394 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15396 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_511 (insn, operands);

            case 8:
              if (!((
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15416 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_514 (insn, operands);

            case 9:
              if (!((
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15416 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_515 (insn, operands);

            case 10:
              if (!(
#line 6016 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS) && 
#line 6018 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_183 (insn, operands);

            case 11:
              if (!(
#line 6016 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID) && 
#line 6018 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_184 (insn, operands);

            case 12:
              if (const_0_to_3_operand (operands[2], E_QImode)
                  && scratch_operand (operands[3], E_V4SImode)
                  && (
#line 4437 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4439 "../../gcc/config/rs6000/vsx.md"
( 1)))
                return gen_split_622 (insn, operands);
              if (!const_int_operand (operands[2], E_QImode)
                  || !scratch_operand (operands[3], E_SImode)
                  || !(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_652 (insn, operands);

            case 13:
              if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_644 (insn, operands);

            case 14:
              if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_648 (insn, operands);

            case 15:
              if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_643 (insn, operands);

            case 16:
              if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_647 (insn, operands);

            case 17:
              if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_651 (insn, operands);

            case 18:
              if (!((
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_645 (insn, operands);

            case 19:
              if (!((
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_649 (insn, operands);

            case 20:
              if (!((
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_653 (insn, operands);

            case 21:
              if (!((
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_646 (insn, operands);

            case 22:
              if (!((
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_650 (insn, operands);

            case 23:
              if (!((
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_654 (insn, operands);

            default:
              return NULL;
            }

        case FIX:
          switch (pattern77 (x1))
            {
            case 0:
              if (nonimmediate_operand (operands[0], E_SImode))
                {
                  switch (pattern455 (
E_DImode))
                    {
                    case 0:
                      if ((
#line 6326 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE) && 
#line 6329 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                        return gen_split_195 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 6326 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE) && 
#line 6329 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                        return gen_split_196 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              if (!memory_operand (operands[0], E_SImode))
                return NULL;
              switch (pattern456 ())
                {
                case 0:
                  if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_211 (insn, operands);

                case 1:
                  if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_217 (insn, operands);

                case 2:
                  if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_496 (insn, operands);

                case 3:
                  if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_502 (insn, operands);

                default:
                  return NULL;
                }

            case 1:
              if (gpc_reg_operand (operands[0], E_QImode))
                {
                  switch (pattern455 (
E_SImode))
                    {
                    case 0:
                      if ((
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], QImode))))
                        return gen_split_199 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], QImode))))
                        return gen_split_203 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              if (!memory_operand (operands[0], E_QImode))
                return NULL;
              switch (pattern457 (
E_QImode))
                {
                case 0:
                  if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_207 (insn, operands);

                case 1:
                  if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_213 (insn, operands);

                case 2:
                  if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_492 (insn, operands);

                case 3:
                  if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_498 (insn, operands);

                default:
                  return NULL;
                }

            case 2:
              if (gpc_reg_operand (operands[0], E_HImode))
                {
                  switch (pattern455 (
E_SImode))
                    {
                    case 0:
                      if ((
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], HImode))))
                        return gen_split_201 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], HImode))))
                        return gen_split_205 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              if (!memory_operand (operands[0], E_HImode))
                return NULL;
              switch (pattern457 (
E_HImode))
                {
                case 0:
                  if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_209 (insn, operands);

                case 1:
                  if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_215 (insn, operands);

                case 2:
                  if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_494 (insn, operands);

                case 3:
                  if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_500 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case UNSIGNED_FIX:
          return split_6 (x1, insn);

        case UNSPEC:
          return split_3 (x1, insn);

        case ZERO_EXTEND:
          if (GET_MODE (x3) != E_DImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!gpc_reg_operand (operands[0], E_DImode))
            return NULL;
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case UNSPEC:
              if (XVECLEN (x6, 0) != 1
                  || XINT (x6, 1) != 87
                  || GET_MODE (x6) != E_SImode)
                return NULL;
              x10 = XVECEXP (x6, 0, 0);
              operands[1] = x10;
              if (!input_operand (operands[1], E_SFmode))
                return NULL;
              x7 = XEXP (x4, 0);
              operands[2] = x7;
              if (!scratch_operand (operands[2], E_V4SFmode)
                  || !(
#line 7892 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT
   && (register_operand (operands[0], DImode)
       || register_operand (operands[1], SImode))) && 
#line 7903 "../../gcc/config/rs6000/rs6000.md"
( reload_completed
   && register_operand (operands[0], DImode)
   && vsx_reg_sfsubreg_ok (operands[1], SFmode))))
                return NULL;
              return gen_split_292 (insn, operands);

            case VEC_SELECT:
              x11 = XEXP (x6, 1);
              if (GET_CODE (x11) != PARALLEL
                  || XVECLEN (x11, 0) != 1)
                return NULL;
              x12 = XEXP (x6, 0);
              operands[1] = x12;
              switch (pattern472 (x1))
                {
                case 0:
                  if (!(
#line 4025 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB) && 
#line 4027 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_603 (insn, operands);

                case 1:
                  if (!(
#line 4025 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB) && 
#line 4027 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_604 (insn, operands);

                case 2:
                  if (!(
#line 4025 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB) && 
#line 4027 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_605 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case FLOAT_EXTEND:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != USE)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_DFmode))
            return NULL;
          switch (pattern342 (x1))
            {
            case 0:
              if (!((
#line 8912 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 8915 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_322 (insn, operands);

            case 1:
              if (!((
#line 8912 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))) && 
#line 8915 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_323 (insn, operands);

            default:
              return NULL;
            }

        case NEG:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!scratch_operand (operands[2], E_V16QImode))
            return NULL;
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[1] = x6;
              switch (pattern293 (x3))
                {
                case 0:
                  if (!((
#line 9299 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 9301 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_330 (insn, operands);

                case 1:
                  if (!((
#line 9299 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 9301 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_331 (insn, operands);

                default:
                  return NULL;
                }

            case ABS:
              x12 = XEXP (x6, 0);
              operands[1] = x12;
              switch (GET_MODE (operands[0]))
                {
                case E_KFmode:
                  if (pattern453 (x3, 
E_KFmode) != 0
                      || !((
#line 9357 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 9359 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_334 (insn, operands);

                case E_TFmode:
                  if (pattern453 (x3, 
E_TFmode) != 0
                      || !((
#line 9357 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 9359 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_335 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case ABS:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          switch (pattern294 (x1))
            {
            case 0:
              if (!((
#line 9327 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 9329 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_332 (insn, operands);

            case 1:
              if (!((
#line 9327 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 9329 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_333 (insn, operands);

            default:
              return NULL;
            }

        case FLOAT_TRUNCATE:
          if (GET_MODE (x3) != E_SFmode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!vsx_register_operand (operands[0], E_SFmode))
            return NULL;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          switch (pattern430 ())
            {
            case 0:
              if (!((
#line 15257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15259 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_490 (insn, operands);

            case 1:
              if (!((
#line 15257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15259 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_491 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x3;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x7 = XEXP (x4, 0);
          switch (pattern298 (x7))
            {
            case 0:
              if (!(
#line 3458 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && VECTOR_MEM_VSX_P (V4SFmode)
   && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V4SFmode)
   && const_vec_duplicate_p (operands[1])) && 
#line 3464 "../../gcc/config/rs6000/vsx.md"
( 1)))
                return NULL;
              return gen_split_588 (insn, operands);

            case 1:
              if (!(
#line 3458 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && VECTOR_MEM_VSX_P (V4SImode)
   && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V4SImode)
   && const_vec_duplicate_p (operands[1])) && 
#line 3464 "../../gcc/config/rs6000/vsx.md"
( 1)))
                return NULL;
              return gen_split_589 (insn, operands);

            default:
              return NULL;
            }

        case VEC_SELECT:
          return split_4 (x1, insn);

        case PLUS:
          if (pattern80 (x1) != 0
              || !(
#line 4927 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4929 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_659 (insn, operands);

        case SMIN:
          if (pattern80 (x1) != 0
              || !(
#line 4927 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4929 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_660 (insn, operands);

        case SMAX:
          if (pattern80 (x1) != 0
              || !(
#line 4927 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4929 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_661 (insn, operands);

        case SIGN_EXTEND:
          if (GET_MODE (x3) != E_TImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER
              || pattern255 (x1, 
E_TImode, 
E_DImode, 
98) != 0)
            return NULL;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!input_operand (operands[1], E_DImode)
              || !(
#line 5133 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && TARGET_POWER10) && 
#line 5135 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_671 (insn, operands);

        case ASHIFT:
          switch (pattern85 (x1))
            {
            case 0:
              if (!((
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)) && 
#line 2200 "../../gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_714 (insn, operands);

            case 1:
              if (!((
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)) && 
#line 2200 "../../gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_717 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFTRT:
          switch (pattern85 (x1))
            {
            case 0:
              if (!((
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)) && 
#line 2200 "../../gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_715 (insn, operands);

            case 1:
              if (!((
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)) && 
#line 2200 "../../gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_718 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          switch (pattern85 (x1))
            {
            case 0:
              if (!((
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)) && 
#line 2200 "../../gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_716 (insn, operands);

            case 1:
              if (!((
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)) && 
#line 2200 "../../gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_719 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 4)
        return NULL;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return NULL;
      x13 = XVECEXP (x2, 0, 0);
      operands[0] = x13;
      if (!register_operand (operands[0], E_DImode))
        return NULL;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      if (!scratch_operand (operands[1], E_DImode)
          || !(
#line 14320 "../../gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return NULL;
      return gen_split_476 (insn, operands);

    default:
      return NULL;
    }
}
